import java.util.Vector; 

/* Copyright K. Lano 2003--2014 
   Package: B AMN */ 

public class BPiExpression extends BExpression
{ private String var;
  private BExpression pred;
  private BExpression value;
  // PI(var).(pred | value)

  public BPiExpression(String v, BExpression p,
                          BExpression val)
  { var = v;
    pred = p;
    value = val;
  }

  public boolean setValued()
  { return false; } 

  public String toString()
  { return "PI(" + var + ").(" + pred + " | " +
           value + ")";
  }

  public Vector rd()
  { Vector res = pred.rd(); 
    res = VectorUtil.union(res,value.rd()); 
    res.remove(var); 
    return res; 
  } 

  public BExpression simplify()
  { BExpression p2 = pred.simplify(); 
    BExpression v2 = value.simplify(); 
    return new BPiExpression(var,p2,v2); 
  } 

  public BExpression substituteEq(String oldE, BExpression newE)
  { if (var.equals(oldE)) { return this; } 
    // also variable capture ...
    if (oldE.equals(toString()))
    { return newE; } 
    
    BExpression npred = pred.substituteEq(oldE,newE); 
    BExpression nval = value.substituteEq(oldE,newE); 
    return new BPiExpression(var,npred,nval); 
  } 
}

