import java.util.Vector; 

/* Copyright K. Lano  2015
  Package: QVT */ 


public class DomainPattern extends Pattern
{ RelationDomain relationDomain;
  TemplateExp templateExpression;

  public DomainPattern(RelationDomain rd, TemplateExp t)
  { relationDomain = rd;
    templateExpression = t;
  }

  public Object clone()
  { TemplateExp te = (TemplateExp) ((ObjectTemplateExp) templateExpression).clone(); 
    return new DomainPattern(relationDomain, te); 
  } 

  public String toString()
  { return "" + templateExpression; }

  public Expression toSourceExpression(Vector bound, Expression contextObj)
  { return templateExpression.toSourceExpression(bound, contextObj); }

  public Expression toTargetExpression(Vector bound, Expression contextObj, Expression setting)
  { return templateExpression.toTargetExpression(bound, contextObj, setting); }

  public Expression toTargetExpressionOp(Vector bound, Expression contextObj, Expression setting)
  { return templateExpression.toTargetExpressionOp(bound, contextObj, setting); }

  public boolean typeCheck(Vector types, Vector entities, Vector contexts, Vector env)
  { return templateExpression.typeCheck(types,entities,contexts,env); } 
}

