import java.util.Vector; 

/* Copyright K. Lano 2015
   Package: QVT
*/ 

public class ObjectTemplateExp extends TemplateExp
{ Entity referredClass;
  Vector part = new Vector(); // PropertyTemplateItem

  public ObjectTemplateExp(Attribute att, Expression ex, Entity e)
  { super(att,ex); 
    referredClass = e; 
  }

  public Object clone()
  { Expression wclone = null; 
    if (where != null) 
    { wclone = (Expression) where.clone(); } 
    ObjectTemplateExp res = new ObjectTemplateExp(bindsTo,wclone,referredClass);
    for (int i = 0; i < part.size(); i++) 
    { PropertyTemplateItem pti = (PropertyTemplateItem) part.get(i); 
      res.addpart((PropertyTemplateItem) pti.clone()); 
    } 
    return res; 
  } 

  public void addpart(PropertyTemplateItem p)
  { part.add(p); }

  public void setpart(Vector parts)
  { part = parts; }

  public Entity getEntity()
  { return referredClass; }

  public boolean typeCheck(Vector types, Vector entities, Vector contexts, Vector env)
  { Vector context = new Vector(); 
    if (referredClass != null) 
    { context.add(referredClass); } 
    context.addAll(contexts); 
    for (int i = 0; i < part.size(); i++) 
    { PropertyTemplateItem p = (PropertyTemplateItem) part.get(i);
      p.typeCheck(types,entities,context,env); 
    } 
    return true; 
  } 

  public Expression toSourceExpression(Vector bound, Expression contextObj)
  { Expression res = new BasicExpression("true");
    for (int i = 0; i < part.size(); i++)
    { PropertyTemplateItem p = (PropertyTemplateItem) part.get(i);
      p.setEntity(referredClass);
      Expression pexp = p.toSourceExpression(bound, contextObj);
      res = Expression.simplify("&",res,pexp,null);
    }
    res = Expression.simplify("&",res,where,null);
    // Expression btexp = new BasicExpression(bindsTo);
    // Expression scope = new BasicExpression(referredClass);
    // Expression decl = new BinaryExpression(":", btexp, scope); 
    // res = Expression.simplify("&",decl,res,null);
    return res;
  }

  public boolean isEmpty()
  { return part.size() == 0; }
  
  public Expression toTargetExpression(Vector bound, Expression contextObj, Expression setting)
  { Expression res = setting; 
    Expression btexp = new BasicExpression(bindsTo);
    boolean alreadybound = bound.contains(bindsTo + ""); 
    // System.out.println("BOUND = " + bound + " " + bindsTo); 

    if (alreadybound) { } 
    else 
    { bound.add(bindsTo + ""); } 

    for (int i = 0; i < part.size(); i++)
    { PropertyTemplateItem p = (PropertyTemplateItem) part.get(i);
      p.setEntity(referredClass);
      Expression pexp = p.toTargetExpression(bound, btexp,null);
      res = Expression.simplify("#&",res,pexp,null);
    }
    res = Expression.simplify("#&",res,where,null);
    if (alreadybound)    
    { return res; } 

    Expression scope = new BasicExpression(referredClass);
    Expression decl = new BinaryExpression(":", btexp, scope); 
    res = new BinaryExpression("#", decl, res);
    return res;
  }

  public Expression toTargetExpressionOp(Vector bound, Expression contextObj, Expression setting)
  { Expression res = setting; 
    Expression btexp = new BasicExpression(bindsTo);
    boolean alreadybound = bound.contains(bindsTo + ""); 
    // System.out.println("BOUND = " + bound + " " + bindsTo); 

    if (alreadybound) { } 
    else 
    { bound.add(bindsTo + ""); } 

    for (int i = 0; i < part.size(); i++)
    { PropertyTemplateItem p = (PropertyTemplateItem) part.get(i);
      p.setEntity(referredClass);
      Expression pexp = p.toTargetExpressionOp(bound, btexp, null);
      res = Expression.simplify("#&",res,pexp,null);
    }
    res = Expression.simplify("#&",res,where,null);
    if (alreadybound)
    { return res; } 
    Expression scope = new BasicExpression(referredClass);
    Expression decl = new BinaryExpression(":", btexp, scope); 
    res = new BinaryExpression("#", decl, res);
    return res;
  }

  public String toString()
  { String res = bindsTo + " : " + referredClass + " { ";
    for (int i = 0; i < part.size(); i++)
    { PropertyTemplateItem p = (PropertyTemplateItem) part.get(i);
      res = res + p;
      if (i < part.size() - 1)
      { res = res + ", "; }
    }
    res = res + " }"; 
    return res;
  } // and { where }
}


