import java.util.List;
import java.util.Date;
import java.util.Map;
import java.util.HashMap;
import java.util.Vector;

import java.lang.*;
import java.lang.reflect.*;
import java.util.StringTokenizer;
import java.io.*;



abstract class ExcelLib
  implements SystemTypes
{

  public ExcelLib()
  {

  }



  public String toString()
  { String _res_ = "(ExcelLib) ";
    return _res_;
  }



    public double SUM(List s)
  {   double result = 0;
 
  result = Set.sumdouble(s);
    return result;
  }


    public double PRODUCT(List s)
  {   double result = 0;
 
  result = Set.prddouble(s);
    return result;
  }


    public double SUMPRODUCT(List s1,List s2)
  {   double result = 0;
    if (s1.size() != s2.size()) { return result; } 
   
  result = Set.sumdouble(Set.collect_0(Set.integerSubrange(1,s1.size()),s1,s2));
    return result;
  }


    public double ESTIMATENSX(List s1,List s2)
  {   double result = 0;
  //  if (s1.size() != s2.size())) { return result; } 
  Controller.inst().initialisensx(s1,s2);
    result = $GeneticAlgorithm.getmaxfitness();
  return result;

  }

    public double AVERAGE(List s)
  {   double result = 0;
 
  if (s.size() == 0) 
  {   result = 0;
 
  }  else
      if (s.size() > 0) 
  {   result = Set.sumdouble(s) / s.size();
 
  }       return result;
  }


    public int DATE(int yr,int month,int day)
  {   int result = 0;
    if (yr < 1900 || month < 1 || day < 1) { return result; } 
   
  result = ( yr - 1900 ) * 360 + ( month - 1 ) * 30 + ( day - 1 );
    return result;
  }


    public double DURATION(int sett,int mat,double coupon,double yield,int freq)
  {   double result = 0;
 
  double period = ( mat - sett ) / 360.0; 
     $Bond b = new $Bond();
    Controller.inst().add$Bond(b);
    b.setcoupon(coupon / freq);
    b.setyield(yield);
    b.setmaturity(period);
    b.setfrequency(freq);
    b.defineFlows1();
    b.defineFlows2();
    result = b.macaulayDuration();
         return result;
  }


    public double DURATIONC(int sett,int mat,double coupon,double yield,int freq)
  {   double result = 0;
 
  double period = ( mat - sett ) / 360.0; 
     $Bond b = new $Bond();
    Controller.inst().add$Bond(b);
    b.setcoupon(coupon / freq);
    b.setyield(yield);
    b.setmaturity(period);
    b.setfrequency(freq);
    b.defineFlows1();
    b.defineFlows2();
    result = b.macaulayDurationC();
         return result;
  }


    public double RATE(int npays,double payment,double pv)
  {   double result = 0;
 
  $Bond b = new $Bond();
    Controller.inst().add$Bond(b);
    b.setcoupon(payment);
    b.setprice(pv);
    b.setmaturity(npays);
    b.setfrequency(1);
    b.defineFlows0();
    b.defineFlows1();
    result = b.dosecant(1.0E-4);
      return result;
  }


    public double RATE(int npays,double payment,double pv,double fv)
  {   double result = 0;
 
  $Bond b = new $Bond();
    Controller.inst().add$Bond(b);
    b.setcoupon(payment);
    b.setprice(pv);
    b.setmaturity(npays);
    b.setfrequency(1);
    b.defineFlows0();
    b.defineFlows1();
    b.defineFlows2();
    result = b.dosecant(1.0E-4);
      return result;
  }


    public double PRICE(int sett,int mat,double crate,double yield,double redempt,int freq)
  {   double result = 0;
 
  double period = ( mat - sett ) / 360.0; 
     $Bond b = new $Bond();
    Controller.inst().add$Bond(b);
    b.setcoupon(crate / freq);
    b.setyield(yield);
    b.setmaturity(period);
    b.setfrequency(freq);
    b.defineFlows1();
    b.defineFlows2();
    result = b.totalValue(yield);
         return result;
  }


    public double MAX(List s)
  {   double result = 0;
 
  if (s.size() == 0) 
  {   result = 0;
 
  }  else
      if (s.size() > 0) 
  {   result = ((Double) Set.max(s)).doubleValue();
 
  }       return result;
  }


    public double MIN(List s)
  {   double result = 0;
 
  if (s.size() == 0) 
  {   result = 0;
 
  }  else
      if (s.size() > 0) 
  {   result = ((Double) Set.min(s)).doubleValue();
 
  }       return result;
  }


    public double SIN(double x)
  {   double result = 0;
 
  result = Math.sin(x);
    return result;
  }


    public double COS(double x)
  {   double result = 0;
 
  result = Math.cos(x);
    return result;
  }


    public double TAN(double x)
  {   double result = 0;
 
  result = Math.tan(x);
    return result;
  }


    public double EXP(double x)
  {   double result = 0;
 
  result = Math.exp(x);
    return result;
  }


    public double LOG(double x)
  {   double result = 0;
 
  result = Math.log(x);
    return result;
  }


    public double SQRT(double x)
  {   double result = 0;
    if (x < 0) { return result; } 
   
  result = Math.sqrt(x);
    return result;
  }


    public double SUMSQDIFFS(List s1,List s2)
  {   double result = 0;
    if (s1.size() != s2.size()) { return result; } 
   
  result = Set.sumdouble(Set.collect_1(Set.integerSubrange(1,s1.size()),s1,s2));
    return result;
  }



}


class Application
  extends ExcelLib
  implements SystemTypes
{

  public Application()
  {

  }



  public String toString()
  { String _res_ = "(Application) ";
    return _res_ + super.toString();
  }

  public static Application parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = new Vector();
    StringTokenizer _st1 =
      new StringTokenizer(_line, ",");
    while (_st1.hasMoreTokens())
    { String _str = _st1.nextToken();
      if (_str != null) 
      { _line1vals.add(_str.trim()); }
    }
    Application applicationx = new Application();
    return applicationx;
  }


  public void writeCSV(PrintWriter _out)
  { Application applicationx = this;
    _out.println();
  }


    public void sheet2(double Diffx)
  { ResultTable resulttablex = new ResultTable();
    Controller.inst().addResultTable(resulttablex);
    Controller.inst().setDiff(resulttablex,Diffx);
  }

    public void sheet2outer()
  {  Application applicationx = this;
    double Diffx;
  Diffx = applicationx.SUMSQDIFFS(Set.collect_2(Controller.inst().pointss),Set.collect_3(Controller.inst().pointss));
     this.sheet2(Diffx);

  }



}


class $Bond
  implements SystemTypes
{
  private double price = 0; // internal
  private double coupon = 0; // internal
  private int frequency = 0; // internal
  private double period = 0; // internal
  private double maturity = 0; // internal
  private double yield = 0; // internal
  private double duration = 0; // internal
  private double weight = 0; // internal
  private double redemption = 0; // internal
  private List flows = new Vector(); // of $CashFlow

  public $Bond()
  {
    this.price = 0;
    this.coupon = 0;
    this.frequency = 0;
    this.period = 0;
    this.maturity = 0;
    this.yield = 0;
    this.duration = 0;
    this.weight = 0;
    this.redemption = 0;

  }



  public String toString()
  { String _res_ = "($Bond) ";
    _res_ = _res_ + price + ",";
    _res_ = _res_ + coupon + ",";
    _res_ = _res_ + frequency + ",";
    _res_ = _res_ + period + ",";
    _res_ = _res_ + maturity + ",";
    _res_ = _res_ + yield + ",";
    _res_ = _res_ + duration + ",";
    _res_ = _res_ + weight + ",";
    _res_ = _res_ + redemption;
    return _res_;
  }

  public static $Bond parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = new Vector();
    StringTokenizer _st1 =
      new StringTokenizer(_line, ",");
    while (_st1.hasMoreTokens())
    { String _str = _st1.nextToken();
      if (_str != null) 
      { _line1vals.add(_str.trim()); }
    }
    $Bond $bondx = new $Bond();
    $bondx.price = Double.parseDouble((String) _line1vals.get(0));
    $bondx.coupon = Double.parseDouble((String) _line1vals.get(1));
    $bondx.frequency = Integer.parseInt((String) _line1vals.get(2));
    $bondx.period = Double.parseDouble((String) _line1vals.get(3));
    $bondx.maturity = Double.parseDouble((String) _line1vals.get(4));
    $bondx.yield = Double.parseDouble((String) _line1vals.get(5));
    $bondx.duration = Double.parseDouble((String) _line1vals.get(6));
    $bondx.weight = Double.parseDouble((String) _line1vals.get(7));
    $bondx.redemption = Double.parseDouble((String) _line1vals.get(8));
    return $bondx;
  }


  public void writeCSV(PrintWriter _out)
  { $Bond $bondx = this;
    _out.print("" + $bondx.price);
    _out.print(" , ");
    _out.print("" + $bondx.coupon);
    _out.print(" , ");
    _out.print("" + $bondx.frequency);
    _out.print(" , ");
    _out.print("" + $bondx.period);
    _out.print(" , ");
    _out.print("" + $bondx.maturity);
    _out.print(" , ");
    _out.print("" + $bondx.yield);
    _out.print(" , ");
    _out.print("" + $bondx.duration);
    _out.print(" , ");
    _out.print("" + $bondx.weight);
    _out.print(" , ");
    _out.print("" + $bondx.redemption);
    _out.println();
  }


  public void setprice(double price_x) { price = price_x;  }


    public static void setAllprice(List $bonds,double val)
  { for (int i = 0; i < $bonds.size(); i++)
    { $Bond $bondx = ($Bond) $bonds.get(i);
      Controller.inst().setprice($bondx,val); } }


  public void setcoupon(double coupon_x) { coupon = coupon_x;  }


    public static void setAllcoupon(List $bonds,double val)
  { for (int i = 0; i < $bonds.size(); i++)
    { $Bond $bondx = ($Bond) $bonds.get(i);
      Controller.inst().setcoupon($bondx,val); } }


  public void setfrequency(int frequency_x) { frequency = frequency_x;  }


    public static void setAllfrequency(List $bonds,int val)
  { for (int i = 0; i < $bonds.size(); i++)
    { $Bond $bondx = ($Bond) $bonds.get(i);
      Controller.inst().setfrequency($bondx,val); } }


  public void setperiod(double period_x) { period = period_x;  }


    public static void setAllperiod(List $bonds,double val)
  { for (int i = 0; i < $bonds.size(); i++)
    { $Bond $bondx = ($Bond) $bonds.get(i);
      Controller.inst().setperiod($bondx,val); } }


  public void setmaturity(double maturity_x) { maturity = maturity_x;  }


    public static void setAllmaturity(List $bonds,double val)
  { for (int i = 0; i < $bonds.size(); i++)
    { $Bond $bondx = ($Bond) $bonds.get(i);
      Controller.inst().setmaturity($bondx,val); } }


  public void setyield(double yield_x) { yield = yield_x;  }


    public static void setAllyield(List $bonds,double val)
  { for (int i = 0; i < $bonds.size(); i++)
    { $Bond $bondx = ($Bond) $bonds.get(i);
      Controller.inst().setyield($bondx,val); } }


  public void setduration(double duration_x) { duration = duration_x;  }


    public static void setAllduration(List $bonds,double val)
  { for (int i = 0; i < $bonds.size(); i++)
    { $Bond $bondx = ($Bond) $bonds.get(i);
      Controller.inst().setduration($bondx,val); } }


  public void setweight(double weight_x) { weight = weight_x;  }


    public static void setAllweight(List $bonds,double val)
  { for (int i = 0; i < $bonds.size(); i++)
    { $Bond $bondx = ($Bond) $bonds.get(i);
      Controller.inst().setweight($bondx,val); } }


  public void setredemption(double redemption_x) { redemption = redemption_x;  }


    public static void setAllredemption(List $bonds,double val)
  { for (int i = 0; i < $bonds.size(); i++)
    { $Bond $bondx = ($Bond) $bonds.get(i);
      Controller.inst().setredemption($bondx,val); } }


  public void setflows(List flows_xx) { flows = flows_xx;
    }
 
  public void setflows(int ind_x, $CashFlow flows_xx) { if (ind_x >= 0 && ind_x < flows.size()) { flows.set(ind_x, flows_xx); } }

 public void addflows($CashFlow flows_xx) { flows.add(flows_xx);
    }
 
  public void removeflows($CashFlow flows_xx) { Vector _removedflowsflows_xx = new Vector();
  _removedflowsflows_xx.add(flows_xx);
  flows.removeAll(_removedflowsflows_xx);
    }

  public static void setAllflows(List $bonds, List _val)
  { for (int _i = 0; _i < $bonds.size(); _i++)
    { $Bond $bondx = ($Bond) $bonds.get(_i);
      Controller.inst().setflows($bondx, _val); } }

  public static void setAllflows(List $bonds, int _ind,$CashFlow _val)
  { for (int _i = 0; _i < $bonds.size(); _i++)
    { $Bond $bondx = ($Bond) $bonds.get(_i);
      Controller.inst().setflows($bondx,_ind,_val); } }

  public static void addAllflows(List $bonds, $CashFlow _val)
  { for (int _i = 0; _i < $bonds.size(); _i++)
    { $Bond $bondx = ($Bond) $bonds.get(_i);
      Controller.inst().addflows($bondx,  _val); } }


  public static void removeAllflows(List $bonds,$CashFlow _val)
  { for (int _i = 0; _i < $bonds.size(); _i++)
    { $Bond $bondx = ($Bond) $bonds.get(_i);
      Controller.inst().removeflows($bondx, _val); } }


  public static void unionAllflows(List $bonds, List _val)
  { for (int _i = 0; _i < $bonds.size(); _i++)
    { $Bond $bondx = ($Bond) $bonds.get(_i);
      Controller.inst().unionflows($bondx, _val); } }


  public static void subtractAllflows(List $bonds,  List _val)
  { for (int _i = 0; _i < $bonds.size(); _i++)
    { $Bond $bondx = ($Bond) $bonds.get(_i);
      Controller.inst().subtractflows($bondx,  _val); } }


    public double getprice() { return price; }

    public static List getAllprice(List $bonds)
  { List result = new Vector();
    for (int i = 0; i < $bonds.size(); i++)
    { $Bond $bondx = ($Bond) $bonds.get(i);
      if (result.contains(new Double($bondx.getprice()))) { }
      else { result.add(new Double($bondx.getprice())); } }
    return result; }

    public static List getAllOrderedprice(List $bonds)
  { List result = new Vector();
    for (int i = 0; i < $bonds.size(); i++)
    { $Bond $bondx = ($Bond) $bonds.get(i);
      result.add(new Double($bondx.getprice())); } 
    return result; }

    public double getcoupon() { return coupon; }

    public static List getAllcoupon(List $bonds)
  { List result = new Vector();
    for (int i = 0; i < $bonds.size(); i++)
    { $Bond $bondx = ($Bond) $bonds.get(i);
      if (result.contains(new Double($bondx.getcoupon()))) { }
      else { result.add(new Double($bondx.getcoupon())); } }
    return result; }

    public static List getAllOrderedcoupon(List $bonds)
  { List result = new Vector();
    for (int i = 0; i < $bonds.size(); i++)
    { $Bond $bondx = ($Bond) $bonds.get(i);
      result.add(new Double($bondx.getcoupon())); } 
    return result; }

    public int getfrequency() { return frequency; }

    public static List getAllfrequency(List $bonds)
  { List result = new Vector();
    for (int i = 0; i < $bonds.size(); i++)
    { $Bond $bondx = ($Bond) $bonds.get(i);
      if (result.contains(new Integer($bondx.getfrequency()))) { }
      else { result.add(new Integer($bondx.getfrequency())); } }
    return result; }

    public static List getAllOrderedfrequency(List $bonds)
  { List result = new Vector();
    for (int i = 0; i < $bonds.size(); i++)
    { $Bond $bondx = ($Bond) $bonds.get(i);
      result.add(new Integer($bondx.getfrequency())); } 
    return result; }

    public double getperiod() { return period; }

    public static List getAllperiod(List $bonds)
  { List result = new Vector();
    for (int i = 0; i < $bonds.size(); i++)
    { $Bond $bondx = ($Bond) $bonds.get(i);
      if (result.contains(new Double($bondx.getperiod()))) { }
      else { result.add(new Double($bondx.getperiod())); } }
    return result; }

    public static List getAllOrderedperiod(List $bonds)
  { List result = new Vector();
    for (int i = 0; i < $bonds.size(); i++)
    { $Bond $bondx = ($Bond) $bonds.get(i);
      result.add(new Double($bondx.getperiod())); } 
    return result; }

    public double getmaturity() { return maturity; }

    public static List getAllmaturity(List $bonds)
  { List result = new Vector();
    for (int i = 0; i < $bonds.size(); i++)
    { $Bond $bondx = ($Bond) $bonds.get(i);
      if (result.contains(new Double($bondx.getmaturity()))) { }
      else { result.add(new Double($bondx.getmaturity())); } }
    return result; }

    public static List getAllOrderedmaturity(List $bonds)
  { List result = new Vector();
    for (int i = 0; i < $bonds.size(); i++)
    { $Bond $bondx = ($Bond) $bonds.get(i);
      result.add(new Double($bondx.getmaturity())); } 
    return result; }

    public double getyield() { return yield; }

    public static List getAllyield(List $bonds)
  { List result = new Vector();
    for (int i = 0; i < $bonds.size(); i++)
    { $Bond $bondx = ($Bond) $bonds.get(i);
      if (result.contains(new Double($bondx.getyield()))) { }
      else { result.add(new Double($bondx.getyield())); } }
    return result; }

    public static List getAllOrderedyield(List $bonds)
  { List result = new Vector();
    for (int i = 0; i < $bonds.size(); i++)
    { $Bond $bondx = ($Bond) $bonds.get(i);
      result.add(new Double($bondx.getyield())); } 
    return result; }

    public double getduration() { return duration; }

    public static List getAllduration(List $bonds)
  { List result = new Vector();
    for (int i = 0; i < $bonds.size(); i++)
    { $Bond $bondx = ($Bond) $bonds.get(i);
      if (result.contains(new Double($bondx.getduration()))) { }
      else { result.add(new Double($bondx.getduration())); } }
    return result; }

    public static List getAllOrderedduration(List $bonds)
  { List result = new Vector();
    for (int i = 0; i < $bonds.size(); i++)
    { $Bond $bondx = ($Bond) $bonds.get(i);
      result.add(new Double($bondx.getduration())); } 
    return result; }

    public double getweight() { return weight; }

    public static List getAllweight(List $bonds)
  { List result = new Vector();
    for (int i = 0; i < $bonds.size(); i++)
    { $Bond $bondx = ($Bond) $bonds.get(i);
      if (result.contains(new Double($bondx.getweight()))) { }
      else { result.add(new Double($bondx.getweight())); } }
    return result; }

    public static List getAllOrderedweight(List $bonds)
  { List result = new Vector();
    for (int i = 0; i < $bonds.size(); i++)
    { $Bond $bondx = ($Bond) $bonds.get(i);
      result.add(new Double($bondx.getweight())); } 
    return result; }

    public double getredemption() { return redemption; }

    public static List getAllredemption(List $bonds)
  { List result = new Vector();
    for (int i = 0; i < $bonds.size(); i++)
    { $Bond $bondx = ($Bond) $bonds.get(i);
      if (result.contains(new Double($bondx.getredemption()))) { }
      else { result.add(new Double($bondx.getredemption())); } }
    return result; }

    public static List getAllOrderedredemption(List $bonds)
  { List result = new Vector();
    for (int i = 0; i < $bonds.size(); i++)
    { $Bond $bondx = ($Bond) $bonds.get(i);
      result.add(new Double($bondx.getredemption())); } 
    return result; }

  public List getflows() { return (Vector) ((Vector) flows).clone(); }

  public static List getAllflows(List $bonds)
  { List result = new Vector();
    for (int _i = 0; _i < $bonds.size(); _i++)
    { $Bond $bondx = ($Bond) $bonds.get(_i);
      result = Set.union(result, $bondx.getflows()); }
    return result; }

  public static List getAllOrderedflows(List $bonds)
  { List result = new Vector();
    for (int _i = 0; _i < $bonds.size(); _i++)
    { $Bond $bondx = ($Bond) $bonds.get(_i);
      result.addAll($bondx.getflows()); }
    return result; }

    public void defineFlows0()
  { $CashFlow f = new $CashFlow();
    Controller.inst().add$CashFlow(f);
    Controller.inst().setamount(f,-this.getprice());
    Controller.inst().settimePoint(f,0);
    Controller.inst().addflows(this,f);
  }

    public void defineFlows1()
  {     List _int_list8 = new Vector();
    _int_list8.addAll(Set.integerSubrange(1,((int) Math.floor(( this.getmaturity() * this.getfrequency() )))));
    for (int _ind9 = 0; _ind9 < _int_list8.size(); _ind9++)
    { int t = ((Integer) _int_list8.get(_ind9)).intValue();
      $CashFlow f = new $CashFlow();
    Controller.inst().add$CashFlow(f);
    Controller.inst().setamount(f,this.getcoupon());
    Controller.inst().settimePoint(f,( t * 1.0 ) / this.getfrequency());
    Controller.inst().addflows(this,f);
    }

  }

    public void defineFlows2()
  { $CashFlow f = new $CashFlow();
    Controller.inst().add$CashFlow(f);
    Controller.inst().setamount(f,100);
    Controller.inst().settimePoint(f,this.getmaturity());
    Controller.inst().addflows(this,f);
  }

    public double totalValue(double r)
  {   double result = 0;
 
  result = Set.sumdouble(Set.collect_4(flows,r));
    return result;
  }


    public double presentValue(double r)
  {   double result = 0;
 
  result = Set.sumdouble(Set.collect_5(flows,this));
    return result;
  }


    public double macaulayDuration()
  {   double result = 0;
 
  double pv = this.totalValue(yield); 
     duration = Set.sumdouble(Set.collect_6(flows,this));
   result = duration / pv;
          return result;
  }


    public double macaulayDurationC()
  {   double result = 0;
 
  double pv = this.presentValue(yield); 
     duration = Set.sumdouble(Set.collect_7(flows,this));
   result = duration / pv;
          return result;
  }


    public double secant(double rn,double rminus,double tvminus,double tol)
  {   double result = 0;
 
  double tvn = this.totalValue(rn); 
     if (Math.abs(tvn) < tol) 
  {   result = rn;
 
  }  else
      if (Math.abs(tvn) >= tol) 
  {   result = this.secant(rn - tvn * ( ( rn - rminus ) / ( tvn - tvminus ) ),rn,tvn,tol);
 
  }          return result;
  }


    public double dosecant(double tol)
  {   double result = 0;
    if (flows.size() <= 0) { return result; } 
   
  double a = Set.sumdouble(Set.collect_8(flows)) + price; 
     double r1 = Math.pow(( a / price ),2.0 / flows.size()) - 1; 
     double totalValue1 = this.totalValue(r1) + price; 
     double p = Math.log(( a / price )) / Math.log(( a / totalValue1 )); 
     double r2 = Math.pow(( 1 + r1 ),p) - 1; 
     result = this.secant(r2,r1,totalValue1 - price,tol);
                   return result;
  }


    public static double nelsonseigalx(double t,double v1,double v2,double v3,double lambda1,double lambda2)
  {   double result = 0;
 
  double tscaled1 = t / lambda1; 
     double tscaled2 = t / lambda2; 
     double exptscaled1 = Math.exp(-tscaled1); 
     double exptscaled2 = Math.exp(-tscaled2); 
     double expratio1 = ( 1 - exptscaled1 ) / tscaled1; 
     double expratio2 = ( 1 - exptscaled2 ) / tscaled2; 
     result = v1 + v2 * expratio1 + v3 * ( expratio2 - exptscaled2 );
                      return result;
  }


    public static double nsx(double t,double v1,double v2,double v3,double lambda1,double lambda2)
  {   double result = 0;
 
  if (t == 0) 
  {   result = v1 + v2;
 
  }  else
      if (t > 0) 
  {   result = $Bond.nelsonseigalx(t,v1,v2,v3,lambda1,lambda2);
 
  }       return result;
  }


    public static List nsxrow($Bond r,double lambda1,double lambda2)
  {   List result = new Vector();
 
  double tscaled1 = r.getduration() / lambda1; 
     double exptscaled1 = Math.exp(-tscaled1); 
     double expratio1 = ( 1 - exptscaled1 ) / tscaled1; 
     double tscaled2 = r.getduration() / lambda2; 
     double exptscaled2 = Math.exp(-tscaled2); 
     double expratio2 = ( 1 - exptscaled2 ) / tscaled2; 
     result = (new SystemTypes.Set()).add(new Double(1.0)).add(new Double(expratio1)).add(new Double(expratio2 - exptscaled2)).getElements();
                      return result;
  }


    public static List nsxmatrix($Bond r1,$Bond r2,$Bond r3,double lambda1,double lambda2)
  {   List result = new Vector();
 
  List row1 = $Bond.nsxrow(r1,lambda1,lambda2); 
     List row2 = $Bond.nsxrow(r2,lambda1,lambda2); 
     List row3 = $Bond.nsxrow(r3,lambda1,lambda2); 
     result = (new SystemTypes.Set()).add(row1).add(row2).add(row3).getElements();
             return result;
  }


    public void initialisensx2()
  { Controller.inst().kill$Bond(this);
  }


}


class $BondGroup
  implements SystemTypes
{
  private double inverseDsum = 0; // internal
  private List bonds = new Vector(); // of $Bond

  public $BondGroup()
  {
    this.inverseDsum = 0;

  }



  public String toString()
  { String _res_ = "($BondGroup) ";
    _res_ = _res_ + inverseDsum;
    return _res_;
  }

  public static $BondGroup parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = new Vector();
    StringTokenizer _st1 =
      new StringTokenizer(_line, ",");
    while (_st1.hasMoreTokens())
    { String _str = _st1.nextToken();
      if (_str != null) 
      { _line1vals.add(_str.trim()); }
    }
    $BondGroup $bondgroupx = new $BondGroup();
    $bondgroupx.inverseDsum = Double.parseDouble((String) _line1vals.get(0));
    return $bondgroupx;
  }


  public void writeCSV(PrintWriter _out)
  { $BondGroup $bondgroupx = this;
    _out.print("" + $bondgroupx.inverseDsum);
    _out.println();
  }


  public void setinverseDsum(double inverseDsum_x) { inverseDsum = inverseDsum_x;  }


    public static void setAllinverseDsum(List $bondgroups,double val)
  { for (int i = 0; i < $bondgroups.size(); i++)
    { $BondGroup $bondgroupx = ($BondGroup) $bondgroups.get(i);
      Controller.inst().setinverseDsum($bondgroupx,val); } }


  public void setbonds(List bonds_xx) { bonds = bonds_xx;
    }
 
  public void addbonds($Bond bonds_xx) { if (bonds.contains(bonds_xx)) {} else { bonds.add(bonds_xx); }
    }
 
  public void removebonds($Bond bonds_xx) { Vector _removedbondsbonds_xx = new Vector();
  _removedbondsbonds_xx.add(bonds_xx);
  bonds.removeAll(_removedbondsbonds_xx);
    }

  public static void setAllbonds(List $bondgroups, List _val)
  { for (int _i = 0; _i < $bondgroups.size(); _i++)
    { $BondGroup $bondgroupx = ($BondGroup) $bondgroups.get(_i);
      Controller.inst().setbonds($bondgroupx, _val); } }

  public static void addAllbonds(List $bondgroups, $Bond _val)
  { for (int _i = 0; _i < $bondgroups.size(); _i++)
    { $BondGroup $bondgroupx = ($BondGroup) $bondgroups.get(_i);
      Controller.inst().addbonds($bondgroupx,  _val); } }


  public static void removeAllbonds(List $bondgroups,$Bond _val)
  { for (int _i = 0; _i < $bondgroups.size(); _i++)
    { $BondGroup $bondgroupx = ($BondGroup) $bondgroups.get(_i);
      Controller.inst().removebonds($bondgroupx, _val); } }


  public static void unionAllbonds(List $bondgroups, List _val)
  { for (int _i = 0; _i < $bondgroups.size(); _i++)
    { $BondGroup $bondgroupx = ($BondGroup) $bondgroups.get(_i);
      Controller.inst().unionbonds($bondgroupx, _val); } }


  public static void subtractAllbonds(List $bondgroups,  List _val)
  { for (int _i = 0; _i < $bondgroups.size(); _i++)
    { $BondGroup $bondgroupx = ($BondGroup) $bondgroups.get(_i);
      Controller.inst().subtractbonds($bondgroupx,  _val); } }


    public double getinverseDsum() { return inverseDsum; }

    public static List getAllinverseDsum(List $bondgroups)
  { List result = new Vector();
    for (int i = 0; i < $bondgroups.size(); i++)
    { $BondGroup $bondgroupx = ($BondGroup) $bondgroups.get(i);
      if (result.contains(new Double($bondgroupx.getinverseDsum()))) { }
      else { result.add(new Double($bondgroupx.getinverseDsum())); } }
    return result; }

    public static List getAllOrderedinverseDsum(List $bondgroups)
  { List result = new Vector();
    for (int i = 0; i < $bondgroups.size(); i++)
    { $BondGroup $bondgroupx = ($BondGroup) $bondgroups.get(i);
      result.add(new Double($bondgroupx.getinverseDsum())); } 
    return result; }

  public List getbonds() { return (Vector) ((Vector) bonds).clone(); }

  public static List getAllbonds(List $bondgroups)
  { List result = new Vector();
    for (int _i = 0; _i < $bondgroups.size(); _i++)
    { $BondGroup $bondgroupx = ($BondGroup) $bondgroups.get(_i);
      result = Set.union(result, $bondgroupx.getbonds()); }
    return result; }

  public static List getAllOrderedbonds(List $bondgroups)
  { List result = new Vector();
    for (int _i = 0; _i < $bondgroups.size(); _i++)
    { $BondGroup $bondgroupx = ($BondGroup) $bondgroups.get(_i);
      result = Set.union(result, $bondgroupx.getbonds()); }
    return result; }


}


class $CashFlow
  implements SystemTypes
{
  private double amount = 0; // internal
  private double timePoint = 0; // internal
  private double rate = 0; // internal
  private double discount = 0; // internal

  public $CashFlow()
  {
    this.amount = 0;
    this.timePoint = 0;
    this.rate = 0;
    this.discount = 0;

  }



  public String toString()
  { String _res_ = "($CashFlow) ";
    _res_ = _res_ + amount + ",";
    _res_ = _res_ + timePoint + ",";
    _res_ = _res_ + rate + ",";
    _res_ = _res_ + discount;
    return _res_;
  }

  public static $CashFlow parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = new Vector();
    StringTokenizer _st1 =
      new StringTokenizer(_line, ",");
    while (_st1.hasMoreTokens())
    { String _str = _st1.nextToken();
      if (_str != null) 
      { _line1vals.add(_str.trim()); }
    }
    $CashFlow $cashflowx = new $CashFlow();
    $cashflowx.amount = Double.parseDouble((String) _line1vals.get(0));
    $cashflowx.timePoint = Double.parseDouble((String) _line1vals.get(1));
    $cashflowx.rate = Double.parseDouble((String) _line1vals.get(2));
    $cashflowx.discount = Double.parseDouble((String) _line1vals.get(3));
    return $cashflowx;
  }


  public void writeCSV(PrintWriter _out)
  { $CashFlow $cashflowx = this;
    _out.print("" + $cashflowx.amount);
    _out.print(" , ");
    _out.print("" + $cashflowx.timePoint);
    _out.print(" , ");
    _out.print("" + $cashflowx.rate);
    _out.print(" , ");
    _out.print("" + $cashflowx.discount);
    _out.println();
  }


  public void setamount(double amount_x) { amount = amount_x;  }


    public static void setAllamount(List $cashflows,double val)
  { for (int i = 0; i < $cashflows.size(); i++)
    { $CashFlow $cashflowx = ($CashFlow) $cashflows.get(i);
      Controller.inst().setamount($cashflowx,val); } }


  public void settimePoint(double timePoint_x) { timePoint = timePoint_x;  }


    public static void setAlltimePoint(List $cashflows,double val)
  { for (int i = 0; i < $cashflows.size(); i++)
    { $CashFlow $cashflowx = ($CashFlow) $cashflows.get(i);
      Controller.inst().settimePoint($cashflowx,val); } }


  public void setrate(double rate_x) { rate = rate_x;  }


    public static void setAllrate(List $cashflows,double val)
  { for (int i = 0; i < $cashflows.size(); i++)
    { $CashFlow $cashflowx = ($CashFlow) $cashflows.get(i);
      Controller.inst().setrate($cashflowx,val); } }


  public void setdiscount(double discount_x) { discount = discount_x;  }


    public static void setAlldiscount(List $cashflows,double val)
  { for (int i = 0; i < $cashflows.size(); i++)
    { $CashFlow $cashflowx = ($CashFlow) $cashflows.get(i);
      Controller.inst().setdiscount($cashflowx,val); } }


    public double getamount() { return amount; }

    public static List getAllamount(List $cashflows)
  { List result = new Vector();
    for (int i = 0; i < $cashflows.size(); i++)
    { $CashFlow $cashflowx = ($CashFlow) $cashflows.get(i);
      if (result.contains(new Double($cashflowx.getamount()))) { }
      else { result.add(new Double($cashflowx.getamount())); } }
    return result; }

    public static List getAllOrderedamount(List $cashflows)
  { List result = new Vector();
    for (int i = 0; i < $cashflows.size(); i++)
    { $CashFlow $cashflowx = ($CashFlow) $cashflows.get(i);
      result.add(new Double($cashflowx.getamount())); } 
    return result; }

    public double gettimePoint() { return timePoint; }

    public static List getAlltimePoint(List $cashflows)
  { List result = new Vector();
    for (int i = 0; i < $cashflows.size(); i++)
    { $CashFlow $cashflowx = ($CashFlow) $cashflows.get(i);
      if (result.contains(new Double($cashflowx.gettimePoint()))) { }
      else { result.add(new Double($cashflowx.gettimePoint())); } }
    return result; }

    public static List getAllOrderedtimePoint(List $cashflows)
  { List result = new Vector();
    for (int i = 0; i < $cashflows.size(); i++)
    { $CashFlow $cashflowx = ($CashFlow) $cashflows.get(i);
      result.add(new Double($cashflowx.gettimePoint())); } 
    return result; }

    public double getrate() { return rate; }

    public static List getAllrate(List $cashflows)
  { List result = new Vector();
    for (int i = 0; i < $cashflows.size(); i++)
    { $CashFlow $cashflowx = ($CashFlow) $cashflows.get(i);
      if (result.contains(new Double($cashflowx.getrate()))) { }
      else { result.add(new Double($cashflowx.getrate())); } }
    return result; }

    public static List getAllOrderedrate(List $cashflows)
  { List result = new Vector();
    for (int i = 0; i < $cashflows.size(); i++)
    { $CashFlow $cashflowx = ($CashFlow) $cashflows.get(i);
      result.add(new Double($cashflowx.getrate())); } 
    return result; }

    public double getdiscount() { return discount; }

    public static List getAlldiscount(List $cashflows)
  { List result = new Vector();
    for (int i = 0; i < $cashflows.size(); i++)
    { $CashFlow $cashflowx = ($CashFlow) $cashflows.get(i);
      if (result.contains(new Double($cashflowx.getdiscount()))) { }
      else { result.add(new Double($cashflowx.getdiscount())); } }
    return result; }

    public static List getAllOrdereddiscount(List $cashflows)
  { List result = new Vector();
    for (int i = 0; i < $cashflows.size(); i++)
    { $CashFlow $cashflowx = ($CashFlow) $cashflows.get(i);
      result.add(new Double($cashflowx.getdiscount())); } 
    return result; }


}


class NelsonSeigal
  implements SystemTypes
{
  private double beta1 = 0; // internal
  private double beta2 = 0; // internal
  private double beta3 = 0; // internal
  private double lambda1 = 0; // internal
  private double lambda2 = 0; // internal

  public NelsonSeigal()
  {
    this.beta1 = 0;
    this.beta2 = 0;
    this.beta3 = 0;
    this.lambda1 = 0;
    this.lambda2 = 0;

  }



  public String toString()
  { String _res_ = "(NelsonSeigal) ";
    _res_ = _res_ + beta1 + ",";
    _res_ = _res_ + beta2 + ",";
    _res_ = _res_ + beta3 + ",";
    _res_ = _res_ + lambda1 + ",";
    _res_ = _res_ + lambda2;
    return _res_;
  }

  public static NelsonSeigal parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = new Vector();
    StringTokenizer _st1 =
      new StringTokenizer(_line, ",");
    while (_st1.hasMoreTokens())
    { String _str = _st1.nextToken();
      if (_str != null) 
      { _line1vals.add(_str.trim()); }
    }
    NelsonSeigal nelsonseigalx = new NelsonSeigal();
    nelsonseigalx.beta1 = Double.parseDouble((String) _line1vals.get(0));
    nelsonseigalx.beta2 = Double.parseDouble((String) _line1vals.get(1));
    nelsonseigalx.beta3 = Double.parseDouble((String) _line1vals.get(2));
    nelsonseigalx.lambda1 = Double.parseDouble((String) _line1vals.get(3));
    nelsonseigalx.lambda2 = Double.parseDouble((String) _line1vals.get(4));
    return nelsonseigalx;
  }


  public void writeCSV(PrintWriter _out)
  { NelsonSeigal nelsonseigalx = this;
    _out.print("" + nelsonseigalx.beta1);
    _out.print(" , ");
    _out.print("" + nelsonseigalx.beta2);
    _out.print(" , ");
    _out.print("" + nelsonseigalx.beta3);
    _out.print(" , ");
    _out.print("" + nelsonseigalx.lambda1);
    _out.print(" , ");
    _out.print("" + nelsonseigalx.lambda2);
    _out.println();
  }


  public void setbeta1(double beta1_x) { beta1 = beta1_x;  }


    public static void setAllbeta1(List nelsonseigals,double val)
  { for (int i = 0; i < nelsonseigals.size(); i++)
    { NelsonSeigal nelsonseigalx = (NelsonSeigal) nelsonseigals.get(i);
      Controller.inst().setbeta1(nelsonseigalx,val); } }


  public void setbeta2(double beta2_x) { beta2 = beta2_x;  }


    public static void setAllbeta2(List nelsonseigals,double val)
  { for (int i = 0; i < nelsonseigals.size(); i++)
    { NelsonSeigal nelsonseigalx = (NelsonSeigal) nelsonseigals.get(i);
      Controller.inst().setbeta2(nelsonseigalx,val); } }


  public void setbeta3(double beta3_x) { beta3 = beta3_x;  }


    public static void setAllbeta3(List nelsonseigals,double val)
  { for (int i = 0; i < nelsonseigals.size(); i++)
    { NelsonSeigal nelsonseigalx = (NelsonSeigal) nelsonseigals.get(i);
      Controller.inst().setbeta3(nelsonseigalx,val); } }


  public void setlambda1(double lambda1_x) { lambda1 = lambda1_x;  }


    public static void setAlllambda1(List nelsonseigals,double val)
  { for (int i = 0; i < nelsonseigals.size(); i++)
    { NelsonSeigal nelsonseigalx = (NelsonSeigal) nelsonseigals.get(i);
      Controller.inst().setlambda1(nelsonseigalx,val); } }


  public void setlambda2(double lambda2_x) { lambda2 = lambda2_x;  }


    public static void setAlllambda2(List nelsonseigals,double val)
  { for (int i = 0; i < nelsonseigals.size(); i++)
    { NelsonSeigal nelsonseigalx = (NelsonSeigal) nelsonseigals.get(i);
      Controller.inst().setlambda2(nelsonseigalx,val); } }


    public double getbeta1() { return beta1; }

    public static List getAllbeta1(List nelsonseigals)
  { List result = new Vector();
    for (int i = 0; i < nelsonseigals.size(); i++)
    { NelsonSeigal nelsonseigalx = (NelsonSeigal) nelsonseigals.get(i);
      if (result.contains(new Double(nelsonseigalx.getbeta1()))) { }
      else { result.add(new Double(nelsonseigalx.getbeta1())); } }
    return result; }

    public static List getAllOrderedbeta1(List nelsonseigals)
  { List result = new Vector();
    for (int i = 0; i < nelsonseigals.size(); i++)
    { NelsonSeigal nelsonseigalx = (NelsonSeigal) nelsonseigals.get(i);
      result.add(new Double(nelsonseigalx.getbeta1())); } 
    return result; }

    public double getbeta2() { return beta2; }

    public static List getAllbeta2(List nelsonseigals)
  { List result = new Vector();
    for (int i = 0; i < nelsonseigals.size(); i++)
    { NelsonSeigal nelsonseigalx = (NelsonSeigal) nelsonseigals.get(i);
      if (result.contains(new Double(nelsonseigalx.getbeta2()))) { }
      else { result.add(new Double(nelsonseigalx.getbeta2())); } }
    return result; }

    public static List getAllOrderedbeta2(List nelsonseigals)
  { List result = new Vector();
    for (int i = 0; i < nelsonseigals.size(); i++)
    { NelsonSeigal nelsonseigalx = (NelsonSeigal) nelsonseigals.get(i);
      result.add(new Double(nelsonseigalx.getbeta2())); } 
    return result; }

    public double getbeta3() { return beta3; }

    public static List getAllbeta3(List nelsonseigals)
  { List result = new Vector();
    for (int i = 0; i < nelsonseigals.size(); i++)
    { NelsonSeigal nelsonseigalx = (NelsonSeigal) nelsonseigals.get(i);
      if (result.contains(new Double(nelsonseigalx.getbeta3()))) { }
      else { result.add(new Double(nelsonseigalx.getbeta3())); } }
    return result; }

    public static List getAllOrderedbeta3(List nelsonseigals)
  { List result = new Vector();
    for (int i = 0; i < nelsonseigals.size(); i++)
    { NelsonSeigal nelsonseigalx = (NelsonSeigal) nelsonseigals.get(i);
      result.add(new Double(nelsonseigalx.getbeta3())); } 
    return result; }

    public double getlambda1() { return lambda1; }

    public static List getAlllambda1(List nelsonseigals)
  { List result = new Vector();
    for (int i = 0; i < nelsonseigals.size(); i++)
    { NelsonSeigal nelsonseigalx = (NelsonSeigal) nelsonseigals.get(i);
      if (result.contains(new Double(nelsonseigalx.getlambda1()))) { }
      else { result.add(new Double(nelsonseigalx.getlambda1())); } }
    return result; }

    public static List getAllOrderedlambda1(List nelsonseigals)
  { List result = new Vector();
    for (int i = 0; i < nelsonseigals.size(); i++)
    { NelsonSeigal nelsonseigalx = (NelsonSeigal) nelsonseigals.get(i);
      result.add(new Double(nelsonseigalx.getlambda1())); } 
    return result; }

    public double getlambda2() { return lambda2; }

    public static List getAlllambda2(List nelsonseigals)
  { List result = new Vector();
    for (int i = 0; i < nelsonseigals.size(); i++)
    { NelsonSeigal nelsonseigalx = (NelsonSeigal) nelsonseigals.get(i);
      if (result.contains(new Double(nelsonseigalx.getlambda2()))) { }
      else { result.add(new Double(nelsonseigalx.getlambda2())); } }
    return result; }

    public static List getAllOrderedlambda2(List nelsonseigals)
  { List result = new Vector();
    for (int i = 0; i < nelsonseigals.size(); i++)
    { NelsonSeigal nelsonseigalx = (NelsonSeigal) nelsonseigals.get(i);
      result.add(new Double(nelsonseigalx.getlambda2())); } 
    return result; }


}


class $GAIndividual
  implements SystemTypes
{
  private double fitnessval = 0; // internal
  private List traits = new Vector(); // of $GATrait

  public $GAIndividual()
  {
    this.fitnessval = 0;

  }



  public String toString()
  { String _res_ = "($GAIndividual) ";
    _res_ = _res_ + fitnessval;
    return _res_;
  }

  public static $GAIndividual parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = new Vector();
    StringTokenizer _st1 =
      new StringTokenizer(_line, ",");
    while (_st1.hasMoreTokens())
    { String _str = _st1.nextToken();
      if (_str != null) 
      { _line1vals.add(_str.trim()); }
    }
    $GAIndividual $gaindividualx = new $GAIndividual();
    $gaindividualx.fitnessval = Double.parseDouble((String) _line1vals.get(0));
    return $gaindividualx;
  }


  public void writeCSV(PrintWriter _out)
  { $GAIndividual $gaindividualx = this;
    _out.print("" + $gaindividualx.fitnessval);
    _out.println();
  }


  public void setfitnessval(double fitnessval_x) { fitnessval = fitnessval_x;  }


    public static void setAllfitnessval(List $gaindividuals,double val)
  { for (int i = 0; i < $gaindividuals.size(); i++)
    { $GAIndividual $gaindividualx = ($GAIndividual) $gaindividuals.get(i);
      Controller.inst().setfitnessval($gaindividualx,val); } }


  public void settraits(List traits_xx) { traits = traits_xx;
    }
 
  public void settraits(int ind_x, $GATrait traits_xx) { if (ind_x >= 0 && ind_x < traits.size()) { traits.set(ind_x, traits_xx); } }

 public void addtraits($GATrait traits_xx) { traits.add(traits_xx);
    }
 
  public void removetraits($GATrait traits_xx) { Vector _removedtraitstraits_xx = new Vector();
  _removedtraitstraits_xx.add(traits_xx);
  traits.removeAll(_removedtraitstraits_xx);
    }

  public static void setAlltraits(List $gaindividuals, List _val)
  { for (int _i = 0; _i < $gaindividuals.size(); _i++)
    { $GAIndividual $gaindividualx = ($GAIndividual) $gaindividuals.get(_i);
      Controller.inst().settraits($gaindividualx, _val); } }

  public static void setAlltraits(List $gaindividuals, int _ind,$GATrait _val)
  { for (int _i = 0; _i < $gaindividuals.size(); _i++)
    { $GAIndividual $gaindividualx = ($GAIndividual) $gaindividuals.get(_i);
      Controller.inst().settraits($gaindividualx,_ind,_val); } }

  public static void addAlltraits(List $gaindividuals, $GATrait _val)
  { for (int _i = 0; _i < $gaindividuals.size(); _i++)
    { $GAIndividual $gaindividualx = ($GAIndividual) $gaindividuals.get(_i);
      Controller.inst().addtraits($gaindividualx,  _val); } }


  public static void removeAlltraits(List $gaindividuals,$GATrait _val)
  { for (int _i = 0; _i < $gaindividuals.size(); _i++)
    { $GAIndividual $gaindividualx = ($GAIndividual) $gaindividuals.get(_i);
      Controller.inst().removetraits($gaindividualx, _val); } }


  public static void unionAlltraits(List $gaindividuals, List _val)
  { for (int _i = 0; _i < $gaindividuals.size(); _i++)
    { $GAIndividual $gaindividualx = ($GAIndividual) $gaindividuals.get(_i);
      Controller.inst().uniontraits($gaindividualx, _val); } }


  public static void subtractAlltraits(List $gaindividuals,  List _val)
  { for (int _i = 0; _i < $gaindividuals.size(); _i++)
    { $GAIndividual $gaindividualx = ($GAIndividual) $gaindividuals.get(_i);
      Controller.inst().subtracttraits($gaindividualx,  _val); } }


    public double getfitnessval() { return fitnessval; }

    public static List getAllfitnessval(List $gaindividuals)
  { List result = new Vector();
    for (int i = 0; i < $gaindividuals.size(); i++)
    { $GAIndividual $gaindividualx = ($GAIndividual) $gaindividuals.get(i);
      if (result.contains(new Double($gaindividualx.getfitnessval()))) { }
      else { result.add(new Double($gaindividualx.getfitnessval())); } }
    return result; }

    public static List getAllOrderedfitnessval(List $gaindividuals)
  { List result = new Vector();
    for (int i = 0; i < $gaindividuals.size(); i++)
    { $GAIndividual $gaindividualx = ($GAIndividual) $gaindividuals.get(i);
      result.add(new Double($gaindividualx.getfitnessval())); } 
    return result; }

  public List gettraits() { return (Vector) ((Vector) traits).clone(); }

  public static List getAlltraits(List $gaindividuals)
  { List result = new Vector();
    for (int _i = 0; _i < $gaindividuals.size(); _i++)
    { $GAIndividual $gaindividualx = ($GAIndividual) $gaindividuals.get(_i);
      result = Set.union(result, $gaindividualx.gettraits()); }
    return result; }

  public static List getAllOrderedtraits(List $gaindividuals)
  { List result = new Vector();
    for (int _i = 0; _i < $gaindividuals.size(); _i++)
    { $GAIndividual $gaindividualx = ($GAIndividual) $gaindividuals.get(_i);
      result.addAll($gaindividualx.gettraits()); }
    return result; }

    public boolean isValid()
  {   boolean result = false;
 
  if ((($GATrait) traits.get(0)).getvalue() + (($GATrait) traits.get(1)).getvalue() > 0) 
  {   result = true;
 
  }    return result;
  }


    public double fitnessnsx()
  {   double result = 0;
 
  double sumsquares = Set.sumdouble(Set.collect_9(Controller.inst().$bonds,this)); 
     result = 100.0 / ( 1 + Math.sqrt(sumsquares) );
       return result;
  }



}


class $GATrait
  implements SystemTypes
{
  private String item = ""; // internal
  private double value = 0; // internal

  public $GATrait()
  {
    this.item = "";
    this.value = 0;

  }



  public String toString()
  { String _res_ = "($GATrait) ";
    _res_ = _res_ + item + ",";
    _res_ = _res_ + value;
    return _res_;
  }

  public static $GATrait parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = new Vector();
    StringTokenizer _st1 =
      new StringTokenizer(_line, ",");
    while (_st1.hasMoreTokens())
    { String _str = _st1.nextToken();
      if (_str != null) 
      { _line1vals.add(_str.trim()); }
    }
    $GATrait $gatraitx = new $GATrait();
    $gatraitx.item = (String) _line1vals.get(0);
    $gatraitx.value = Double.parseDouble((String) _line1vals.get(1));
    return $gatraitx;
  }


  public void writeCSV(PrintWriter _out)
  { $GATrait $gatraitx = this;
    _out.print("" + $gatraitx.item);
    _out.print(" , ");
    _out.print("" + $gatraitx.value);
    _out.println();
  }


  public void setitem(String item_x) { item = item_x;  }


    public static void setAllitem(List $gatraits,String val)
  { for (int i = 0; i < $gatraits.size(); i++)
    { $GATrait $gatraitx = ($GATrait) $gatraits.get(i);
      Controller.inst().setitem($gatraitx,val); } }


  public void setvalue(double value_x) { value = value_x;  }


    public static void setAllvalue(List $gatraits,double val)
  { for (int i = 0; i < $gatraits.size(); i++)
    { $GATrait $gatraitx = ($GATrait) $gatraits.get(i);
      Controller.inst().setvalue($gatraitx,val); } }


    public String getitem() { return item; }

    public static List getAllitem(List $gatraits)
  { List result = new Vector();
    for (int i = 0; i < $gatraits.size(); i++)
    { $GATrait $gatraitx = ($GATrait) $gatraits.get(i);
      if (result.contains($gatraitx.getitem())) { }
      else { result.add($gatraitx.getitem()); } }
    return result; }

    public static List getAllOrdereditem(List $gatraits)
  { List result = new Vector();
    for (int i = 0; i < $gatraits.size(); i++)
    { $GATrait $gatraitx = ($GATrait) $gatraits.get(i);
      result.add($gatraitx.getitem()); } 
    return result; }

    public double getvalue() { return value; }

    public static List getAllvalue(List $gatraits)
  { List result = new Vector();
    for (int i = 0; i < $gatraits.size(); i++)
    { $GATrait $gatraitx = ($GATrait) $gatraits.get(i);
      if (result.contains(new Double($gatraitx.getvalue()))) { }
      else { result.add(new Double($gatraitx.getvalue())); } }
    return result; }

    public static List getAllOrderedvalue(List $gatraits)
  { List result = new Vector();
    for (int i = 0; i < $gatraits.size(); i++)
    { $GATrait $gatraitx = ($GATrait) $gatraits.get(i);
      result.add(new Double($gatraitx.getvalue())); } 
    return result; }


}


class $GeneticAlgorithm
  implements SystemTypes
{
  private static double maxfitness = 0; // internal
  private List population = new Vector(); // of $GAIndividual

  public $GeneticAlgorithm()
  {
    this.maxfitness = 0;

  }



  public String toString()
  { String _res_ = "($GeneticAlgorithm) ";
    _res_ = _res_ + maxfitness;
    return _res_;
  }

  public static $GeneticAlgorithm parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = new Vector();
    StringTokenizer _st1 =
      new StringTokenizer(_line, ",");
    while (_st1.hasMoreTokens())
    { String _str = _st1.nextToken();
      if (_str != null) 
      { _line1vals.add(_str.trim()); }
    }
    $GeneticAlgorithm $geneticalgorithmx = new $GeneticAlgorithm();
    $geneticalgorithmx.maxfitness = Double.parseDouble((String) _line1vals.get(0));
    return $geneticalgorithmx;
  }


  public void writeCSV(PrintWriter _out)
  { $GeneticAlgorithm $geneticalgorithmx = this;
    _out.print("" + $geneticalgorithmx.maxfitness);
    _out.println();
  }


  public static void setmaxfitness(double maxfitness_x) { maxfitness = maxfitness_x; }

public void localSetmaxfitness(double maxfitness_x) {   }


    public static void setAllmaxfitness(List $geneticalgorithms,double val)
  { for (int i = 0; i < $geneticalgorithms.size(); i++)
    { $GeneticAlgorithm $geneticalgorithmx = ($GeneticAlgorithm) $geneticalgorithms.get(i);
      Controller.inst().setmaxfitness($geneticalgorithmx,val); } }


  public void setpopulation(List population_xx) { population = population_xx;
    }
 
  public void addpopulation($GAIndividual population_xx) { if (population.contains(population_xx)) {} else { population.add(population_xx); }
    }
 
  public void removepopulation($GAIndividual population_xx) { Vector _removedpopulationpopulation_xx = new Vector();
  _removedpopulationpopulation_xx.add(population_xx);
  population.removeAll(_removedpopulationpopulation_xx);
    }

  public static void setAllpopulation(List $geneticalgorithms, List _val)
  { for (int _i = 0; _i < $geneticalgorithms.size(); _i++)
    { $GeneticAlgorithm $geneticalgorithmx = ($GeneticAlgorithm) $geneticalgorithms.get(_i);
      Controller.inst().setpopulation($geneticalgorithmx, _val); } }

  public static void addAllpopulation(List $geneticalgorithms, $GAIndividual _val)
  { for (int _i = 0; _i < $geneticalgorithms.size(); _i++)
    { $GeneticAlgorithm $geneticalgorithmx = ($GeneticAlgorithm) $geneticalgorithms.get(_i);
      Controller.inst().addpopulation($geneticalgorithmx,  _val); } }


  public static void removeAllpopulation(List $geneticalgorithms,$GAIndividual _val)
  { for (int _i = 0; _i < $geneticalgorithms.size(); _i++)
    { $GeneticAlgorithm $geneticalgorithmx = ($GeneticAlgorithm) $geneticalgorithms.get(_i);
      Controller.inst().removepopulation($geneticalgorithmx, _val); } }


  public static void unionAllpopulation(List $geneticalgorithms, List _val)
  { for (int _i = 0; _i < $geneticalgorithms.size(); _i++)
    { $GeneticAlgorithm $geneticalgorithmx = ($GeneticAlgorithm) $geneticalgorithms.get(_i);
      Controller.inst().unionpopulation($geneticalgorithmx, _val); } }


  public static void subtractAllpopulation(List $geneticalgorithms,  List _val)
  { for (int _i = 0; _i < $geneticalgorithms.size(); _i++)
    { $GeneticAlgorithm $geneticalgorithmx = ($GeneticAlgorithm) $geneticalgorithms.get(_i);
      Controller.inst().subtractpopulation($geneticalgorithmx,  _val); } }


    public static double getmaxfitness() { return maxfitness; }

    public static List getAllmaxfitness(List $geneticalgorithms)
  { List result = new Vector();
   if ($geneticalgorithms.size() > 0)
   { result.add(new Double($GeneticAlgorithm.maxfitness)); }
    return result; }

    public static List getAllOrderedmaxfitness(List $geneticalgorithms)
  { List result = new Vector();
    for (int i = 0; i < $geneticalgorithms.size(); i++)
    { $GeneticAlgorithm $geneticalgorithmx = ($GeneticAlgorithm) $geneticalgorithms.get(i);
      result.add(new Double($geneticalgorithmx.getmaxfitness())); } 
    return result; }

  public List getpopulation() { return (Vector) ((Vector) population).clone(); }

  public static List getAllpopulation(List $geneticalgorithms)
  { List result = new Vector();
    for (int _i = 0; _i < $geneticalgorithms.size(); _i++)
    { $GeneticAlgorithm $geneticalgorithmx = ($GeneticAlgorithm) $geneticalgorithms.get(_i);
      result = Set.union(result, $geneticalgorithmx.getpopulation()); }
    return result; }

  public static List getAllOrderedpopulation(List $geneticalgorithms)
  { List result = new Vector();
    for (int _i = 0; _i < $geneticalgorithms.size(); _i++)
    { $GeneticAlgorithm $geneticalgorithmx = ($GeneticAlgorithm) $geneticalgorithms.get(_i);
      result = Set.union(result, $geneticalgorithmx.getpopulation()); }
    return result; }

    public void initialisensx4(double lambda1,double lambda2,$Bond r1,$Bond r2,$Bond r3,List m,double d)
  { $GAIndividual ind = new $GAIndividual();
    Controller.inst().add$GAIndividual(ind);
    $GATrait t1 = new $GATrait();
    Controller.inst().add$GATrait(t1);
    Controller.inst().setitem(t1,"beta1");
    Controller.inst().setvalue(t1,$Matrix.lineqn3solution1(m,d,-r1.getyield(),-r2.getyield(),-r3.getyield()));
    Controller.inst().addtraits(ind,t1);
    $GATrait t2 = new $GATrait();
    Controller.inst().add$GATrait(t2);
    Controller.inst().setitem(t2,"beta2");
    Controller.inst().setvalue(t2,$Matrix.lineqn3solution2(m,d,-r1.getyield(),-r2.getyield(),-r3.getyield()));
    Controller.inst().addtraits(ind,t2);
    $GATrait t3 = new $GATrait();
    Controller.inst().add$GATrait(t3);
    Controller.inst().setitem(t3,"beta3");
    Controller.inst().setvalue(t3,$Matrix.lineqn3solution3(m,d,-r1.getyield(),-r2.getyield(),-r3.getyield()));
    Controller.inst().addtraits(ind,t3);
    $GATrait t4 = new $GATrait();
    Controller.inst().add$GATrait(t4);
    Controller.inst().setitem(t4,"lambda1");
    Controller.inst().setvalue(t4,lambda1);
    Controller.inst().addtraits(ind,t4);
    $GATrait t5 = new $GATrait();
    Controller.inst().add$GATrait(t5);
    Controller.inst().setitem(t5,"lambda2");
    Controller.inst().setvalue(t5,lambda2);
    Controller.inst().addtraits(ind,t5);
    Controller.inst().addpopulation(this,ind);
  }

    public void initialisensx4outer()
  {  $GeneticAlgorithm $geneticalgorithmx = this;
    List _range11 = new Vector();
  _range11.addAll((new SystemTypes.Set()).add(new Double(0.5)).add(new Double(1.0)).add(new Double(1.5)).add(new Double(2.0)).add(new Double(2.5)).add(new Double(3.0)).add(new Double(3.5)).getElements());
  for (int _i10 = 0; _i10 < _range11.size(); _i10++)
  { double lambda1 = ((Double) _range11.get(_i10)).doubleValue();
      List _range13 = new Vector();
  _range13.addAll((new SystemTypes.Set()).add(new Double(0.75)).add(new Double(1.2)).add(new Double(1.7)).add(new Double(2.2)).add(new Double(2.7)).getElements());
  for (int _i12 = 0; _i12 < _range13.size(); _i12++)
  { double lambda2 = ((Double) _range13.get(_i12)).doubleValue();
      List _range15 = new Vector();
  _range15.addAll(Controller.inst().$bonds);
  for (int _i14 = 0; _i14 < _range15.size(); _i14++)
  { $Bond r1 = ($Bond) _range15.get(_i14);
      List _range17 = new Vector();
  _range17.addAll(Controller.inst().$bonds);
  for (int _i16 = 0; _i16 < _range17.size(); _i16++)
  { $Bond r2 = ($Bond) _range17.get(_i16);
      List _range19 = new Vector();
  _range19.addAll(Controller.inst().$bonds);
  for (int _i18 = 0; _i18 < _range19.size(); _i18++)
  { $Bond r3 = ($Bond) _range19.get(_i18);
       if (r1.getduration() < r2.getduration()) {    if (r2.getduration() < r3.getduration()) {   List m;
    m = new Vector();
  m.addAll($Bond.nsxmatrix(r1,r2,r3,lambda1,lambda2));

    double d;
  d = $Matrix.determinant3(m);
     if (d != 0) {    this.initialisensx4(lambda1,lambda2,r1,r2,r3,m,d); }


 }
 }

  }
  }
  }
  }
  }
  }


    public void initialisensx5($GAIndividual p)
  { Controller.inst().setfitnessval(p,p.fitnessnsx());
  }

    public void initialisensx5outer()
  {  $GeneticAlgorithm $geneticalgorithmx = this;
    List _range21 = new Vector();
  _range21.addAll($geneticalgorithmx.getpopulation());
  for (int _i20 = 0; _i20 < _range21.size(); _i20++)
  { $GAIndividual p = ($GAIndividual) _range21.get(_i20);
       if (p.isValid()) {    this.initialisensx5(p); }

  }
  }


    public void initialisensx6()
  {   if (this.getpopulation().size() > 0) 
  { $GeneticAlgorithm.setmaxfitness(((Double) Set.max(Set.collect_10(this.getpopulation()))).doubleValue());}
  }

    public void initialisensx7()
  {   System.out.println("" + ( "Population size = " + this.getpopulation().size() ));

      System.out.println("" + ( "Max fitness = " + $GeneticAlgorithm.getmaxfitness() ));

  }

    public void initialisensx8($GAIndividual maxresult)
  { NelsonSeigal ns = new NelsonSeigal();
    Controller.inst().addNelsonSeigal(ns);
    Controller.inst().setbeta1(ns,(($GATrait) (maxresult.gettraits().get(0))).getvalue());
    Controller.inst().setbeta2(ns,(($GATrait) (maxresult.gettraits().get(1))).getvalue());
    Controller.inst().setbeta3(ns,(($GATrait) (maxresult.gettraits().get(2))).getvalue());
    Controller.inst().setlambda1(ns,(($GATrait) (maxresult.gettraits().get(3))).getvalue());
    Controller.inst().setlambda2(ns,(($GATrait) (maxresult.gettraits().get(4))).getvalue());
  }

    public void initialisensx8outer()
  {  $GeneticAlgorithm $geneticalgorithmx = this;
    $GAIndividual maxresult = (($GAIndividual) Set.any(Set.maximalElements($geneticalgorithmx.getpopulation(), Set.collect_10($geneticalgorithmx.getpopulation()))));
     this.initialisensx8(maxresult);

  }


    public void initialisensx9($GAIndividual maxresult)
  { $NSXFunction nsxf = new $NSXFunction();
    Controller.inst().add$NSXFunction(nsxf);
    $SimplexPoint p = new $SimplexPoint();
    Controller.inst().add$SimplexPoint(p);
    Controller.inst().setcoords(p,(new SystemTypes.Set()).add(new Double((($GATrait) (maxresult.gettraits().get(0))).getvalue())).add(new Double((($GATrait) (maxresult.gettraits().get(1))).getvalue())).add(new Double((($GATrait) (maxresult.gettraits().get(2))).getvalue())).add(new Double((($GATrait) (maxresult.gettraits().get(3))).getvalue())).add(new Double((($GATrait) (maxresult.gettraits().get(4))).getvalue())).getElements());
    $Simplex sx = new $Simplex();
    Controller.inst().add$Simplex(sx);
    Controller.inst().setf(sx,nsxf);
    Controller.inst().setdim(sx,5);
      System.out.println("" + sx.iterate(p,1.0E-5));

  }

    public void initialisensx9outer()
  {  $GeneticAlgorithm $geneticalgorithmx = this;
    $GAIndividual maxresult = (($GAIndividual) Set.any(Set.maximalElements($geneticalgorithmx.getpopulation(), Set.collect_10($geneticalgorithmx.getpopulation()))));
     this.initialisensx9(maxresult);

  }



}


class $Sequences
  implements SystemTypes
{

  public $Sequences()
  {

  }



  public String toString()
  { String _res_ = "($Sequences) ";
    return _res_;
  }

  public static $Sequences parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = new Vector();
    StringTokenizer _st1 =
      new StringTokenizer(_line, ",");
    while (_st1.hasMoreTokens())
    { String _str = _st1.nextToken();
      if (_str != null) 
      { _line1vals.add(_str.trim()); }
    }
    $Sequences $sequencesx = new $Sequences();
    return $sequencesx;
  }


  public void writeCSV(PrintWriter _out)
  { $Sequences $sequencesx = this;
    _out.println();
  }


    public static List toColumn(List s)
  {   List result = new Vector();
 
  result = Set.collect_11(s);
    return result;
  }


    public static List subItems(List s,List inds)
  {   List result = new Vector();
 
  result = Set.collect_13(Set.select_12(inds,s),s);
    return result;
  }


    public static List sqFloor(List s)
  {   List result = new Vector();
 
  result = Set.collect_14(s);
    return result;
  }


    public static List sqRound(List s)
  {   List result = new Vector();
 
  result = Set.collect_15(s);
    return result;
  }


    public static List sqAbs(List s)
  {   List result = new Vector();
 
  result = Set.collect_16(s);
    return result;
  }


    public static List sqCeil(List s)
  {   List result = new Vector();
 
  result = Set.collect_17(s);
    return result;
  }


    public static List sqEq(List s,double v)
  {   List result = new Vector();
 
  result = Set.collect_18(s,v);
    return result;
  }


    public static List sqLeq(List s,double v)
  {   List result = new Vector();
 
  result = Set.collect_19(s,v);
    return result;
  }


    public static List sqLess(List s,double v)
  {   List result = new Vector();
 
  result = Set.collect_20(s,v);
    return result;
  }


    public static List sqAdd(List s,double v)
  {   List result = new Vector();
 
  result = Set.collect_21(s,v);
    return result;
  }


    public static List sqAverage(List m)
  {   List result = new Vector();
 
  result = Set.collect_23(Set.integerSubrange(1,((List) m.get(0)).size()),m);
    return result;
  }


    public static List ssAdd(List s1,List s2)
  {   List result = new Vector();
    if (s1.size() != s2.size()) { return result; } 
   
  result = Set.collect_24(Set.integerSubrange(1,s1.size()),s1,s2);
    return result;
  }


    public static List ssSubtract(List s1,List s2)
  {   List result = new Vector();
    if (s1.size() != s2.size()) { return result; } 
   
  result = Set.collect_25(Set.integerSubrange(1,s1.size()),s1,s2);
    return result;
  }


    public static List sqMult(List ss,double v)
  {   List result = new Vector();
 
  result = Set.collect_26(ss,v);
    return result;
  }


    public static List ssMult(List s1,List s2)
  {   List result = new Vector();
    if (s1.size() != s2.size()) { return result; } 
   
  result = Set.collect_0(Set.integerSubrange(1,s1.size()),s1,s2);
    return result;
  }


    public static double distance(List s1,List s2)
  {   double result = 0;
    if (s1.size() != s2.size()) { return result; } 
   
  result = Math.sqrt(Set.sumdouble(Set.collect_1(Set.integerSubrange(1,s1.size()),s1,s2)));
    return result;
  }



}


class $Matrix
  implements SystemTypes
{

  public $Matrix()
  {

  }



  public String toString()
  { String _res_ = "($Matrix) ";
    return _res_;
  }

  public static $Matrix parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = new Vector();
    StringTokenizer _st1 =
      new StringTokenizer(_line, ",");
    while (_st1.hasMoreTokens())
    { String _str = _st1.nextToken();
      if (_str != null) 
      { _line1vals.add(_str.trim()); }
    }
    $Matrix $matrixx = new $Matrix();
    return $matrixx;
  }


  public void writeCSV(PrintWriter _out)
  { $Matrix $matrixx = this;
    _out.println();
  }


    public static double determinant2(List m)
  {   double result = 0;
    if (m.size() != 2 || (((List) m.get(0))).size() != 2) { return result; } 
   
  double a1 = ((Double) ((List) m.get(0)).get(1 - 1)).doubleValue(); 
     double a2 = ((Double) ((List) m.get(0)).get(2 - 1)).doubleValue(); 
     double b1 = ((Double) ((List) m.get(1)).get(1 - 1)).doubleValue(); 
     double b2 = ((Double) ((List) m.get(1)).get(2 - 1)).doubleValue(); 
     result = a1 * b2 - a2 * b1;
                return result;
  }


    public static double detaux(double x1,double y1,double x2,double y2)
  {   double result = 0;
 
  result = x1 * y1 - x2 * y2;
    return result;
  }


    public static double determinant3(List m)
  {   double result = 0;
    if (m.size() != 3 || (((List) m.get(0))).size() != 3) { return result; } 
   
  result = ((Double) ((List) m.get(0)).get(1 - 1)).doubleValue() * $Matrix.detaux(((Double) ((List) m.get(1)).get(2 - 1)).doubleValue(),((Double) ((List) m.get(2)).get(3 - 1)).doubleValue(),((Double) ((List) m.get(1)).get(3 - 1)).doubleValue(),((Double) ((List) m.get(2)).get(2 - 1)).doubleValue()) - ((Double) ((List) m.get(0)).get(2 - 1)).doubleValue() * $Matrix.detaux(((Double) ((List) m.get(1)).get(1 - 1)).doubleValue(),((Double) ((List) m.get(2)).get(3 - 1)).doubleValue(),((Double) ((List) m.get(2)).get(1 - 1)).doubleValue(),((Double) ((List) m.get(1)).get(3 - 1)).doubleValue()) + ((Double) ((List) m.get(0)).get(3 - 1)).doubleValue() * $Matrix.detaux(((Double) ((List) m.get(1)).get(1 - 1)).doubleValue(),((Double) ((List) m.get(2)).get(2 - 1)).doubleValue(),((Double) ((List) m.get(1)).get(2 - 1)).doubleValue(),((Double) ((List) m.get(2)).get(1 - 1)).doubleValue());
    return result;
  }


    public static double lineqn3solution1(List m,double d,double d1,double d2,double d3)
  {   double result = 0;
    if (m.size() != 3 || (((List) m.get(0))).size() != 3 || d == 0) { return result; } 
   
  List m1 = (new SystemTypes.Set()).add((new SystemTypes.Set()).add(new Double(((Double) ((List) m.get(0)).get(2 - 1)).doubleValue())).add(new Double(((Double) ((List) m.get(0)).get(3 - 1)).doubleValue())).add(new Double(d1)).getElements()).add((new SystemTypes.Set()).add(new Double(((Double) ((List) m.get(1)).get(2 - 1)).doubleValue())).add(new Double(((Double) ((List) m.get(1)).get(3 - 1)).doubleValue())).add(new Double(d2)).getElements()).add((new SystemTypes.Set()).add(new Double(((Double) ((List) m.get(2)).get(2 - 1)).doubleValue())).add(new Double(((Double) ((List) m.get(2)).get(3 - 1)).doubleValue())).add(new Double(d3)).getElements()).getElements(); 
     result = -$Matrix.determinant3(m1) / d;
       return result;
  }


    public static double lineqn3solution2(List m,double d,double d1,double d2,double d3)
  {   double result = 0;
    if (m.size() != 3 || (((List) m.get(0))).size() != 3 || d == 0) { return result; } 
   
  List m1 = (new SystemTypes.Set()).add((new SystemTypes.Set()).add(new Double(((Double) ((List) m.get(0)).get(1 - 1)).doubleValue())).add(new Double(((Double) ((List) m.get(0)).get(3 - 1)).doubleValue())).add(new Double(d1)).getElements()).add((new SystemTypes.Set()).add(new Double(((Double) ((List) m.get(1)).get(1 - 1)).doubleValue())).add(new Double(((Double) ((List) m.get(1)).get(3 - 1)).doubleValue())).add(new Double(d2)).getElements()).add((new SystemTypes.Set()).add(new Double(((Double) ((List) m.get(2)).get(1 - 1)).doubleValue())).add(new Double(((Double) ((List) m.get(2)).get(3 - 1)).doubleValue())).add(new Double(d3)).getElements()).getElements(); 
     result = $Matrix.determinant3(m1) / d;
       return result;
  }


    public static double lineqn3solution3(List m,double d,double d1,double d2,double d3)
  {   double result = 0;
    if (m.size() != 3 || (((List) m.get(0))).size() != 3 || d == 0) { return result; } 
   
  List m1 = (new SystemTypes.Set()).add((new SystemTypes.Set()).add(new Double(((Double) ((List) m.get(0)).get(1 - 1)).doubleValue())).add(new Double(((Double) ((List) m.get(0)).get(2 - 1)).doubleValue())).add(new Double(d1)).getElements()).add((new SystemTypes.Set()).add(new Double(((Double) ((List) m.get(1)).get(1 - 1)).doubleValue())).add(new Double(((Double) ((List) m.get(1)).get(2 - 1)).doubleValue())).add(new Double(d2)).getElements()).add((new SystemTypes.Set()).add(new Double(((Double) ((List) m.get(2)).get(1 - 1)).doubleValue())).add(new Double(((Double) ((List) m.get(2)).get(2 - 1)).doubleValue())).add(new Double(d3)).getElements()).getElements(); 
     result = -$Matrix.determinant3(m1) / d;
       return result;
  }


    public static List matrixMult(List s,double v)
  {   List result = new Vector();
 
  result = Set.collect_27(s,v);
    return result;
  }


    public static List mmMult(List m1,List m2)
  {   List result = new Vector();
    if (m1.size() != m2.size()) { return result; } 
   
  result = Set.collect_28(Set.integerSubrange(1,m1.size()),m1,m2);
    return result;
  }


    public static List rowMult(List s,List m)
  {   List result = new Vector();
 
  int sze = ((Integer) Set.min((new SystemTypes.Set()).add(new Integer(s.size())).add(new Integer(((List) m.get(0)).size())).getElements())).intValue(); 
     result = Set.collect_30(Set.integerSubrange(1,sze),m,s);
       return result;
  }


    public static List matrixProd(List m1,List m2)
  {   List result = new Vector();
 
  result = Set.collect_31(m1,m2);
    return result;
  }


    public static List toRow(List m)
  {   List result = new Vector();
 
  result = Set.collect_32(m);
    return result;
  }


    public static List cofactorMatrix(List m,int i,int j)
  {   List result = new Vector();
 
  result = Set.collect_33(( Set.concatenate(Set.subrange(m,1,i - 1),Set.subrange(m,i + 1,m.size())) ),j);
    return result;
  }


    public static double cofactor(List m,int i,int j)
  {   double result = 0;
 
  int weight = 1 - 2 * ( ( i + j ) % 2 ); 
     result = weight * $Matrix.determinant($Matrix.cofactorMatrix(m,i,j));
       return result;
  }


    public static double determinant4(List m)
  {   double result = 0;
    if (m.size() < 3 || (((List) m.get(0))).size() < 3) { return result; } 
   
  result = Set.sumdouble(Set.collect_34(Set.integerSubrange(1,((List) m.get(0)).size()),m));
    return result;
  }


    public static double determinant(List m)
  {   double result = 0;
    if (m.size() != (((List) m.get(0))).size()) { return result; } 
   
  if (m.size() == 1) 
  {   result = ((Double) ((List) m.get(0)).get(1 - 1)).doubleValue();
 
  }  else
      {   if (m.size() == 2) 
  {   result = $Matrix.determinant2(m);
 
  }  else
      {   if (m.size() == 3) 
  {   result = $Matrix.determinant3(m);
 
  }  else
      if (m.size() > 3) 
  {   result = $Matrix.determinant4(m);
 
  }   
   } 
   }     return result;
  }


    public static List adjoint(List m)
  {   List result = new Vector();
 
  result = Set.collect_36(Set.integerSubrange(1,m.size()),m);
    return result;
  }


    public static List inverse(List m)
  {   List result = new Vector();
 
  result = $Matrix.matrixMult($Matrix.adjoint(m),1.0 / $Matrix.determinant(m));
    return result;
  }


    public static List solveEquations(List m,List y)
  {   List result = new Vector();
 
  result = $Matrix.toRow($Matrix.matrixProd($Matrix.inverse(m),$Sequences.toColumn(y)));
    return result;
  }



}


class Initialisensx
  implements SystemTypes
{

  public Initialisensx()
  {

  }



  public String toString()
  { String _res_ = "(Initialisensx) ";
    return _res_;
  }

  public static Initialisensx parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = new Vector();
    StringTokenizer _st1 =
      new StringTokenizer(_line, ",");
    while (_st1.hasMoreTokens())
    { String _str = _st1.nextToken();
      if (_str != null) 
      { _line1vals.add(_str.trim()); }
    }
    Initialisensx initialisensxx = new Initialisensx();
    return initialisensxx;
  }


  public void writeCSV(PrintWriter _out)
  { Initialisensx initialisensxx = this;
    _out.println();
  }


  


}


class $SimplexPoint
  implements SystemTypes
{
  private List coords = new Vector(); // internal
  private double fval = 0; // internal

  public $SimplexPoint()
  {
    this.coords = (new SystemTypes.Set()).getElements();
    this.fval = 0;

  }



  public String toString()
  { String _res_ = "($SimplexPoint) ";
    _res_ = _res_ + coords + ",";
    _res_ = _res_ + fval;
    return _res_;
  }

  public static $SimplexPoint parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = new Vector();
    StringTokenizer _st1 =
      new StringTokenizer(_line, ",");
    while (_st1.hasMoreTokens())
    { String _str = _st1.nextToken();
      if (_str != null) 
      { _line1vals.add(_str.trim()); }
    }
    $SimplexPoint $simplexpointx = new $SimplexPoint();
    $simplexpointx.fval = Double.parseDouble((String) _line1vals.get(1));
    return $simplexpointx;
  }


  public void writeCSV(PrintWriter _out)
  { $SimplexPoint $simplexpointx = this;
    _out.print("" + $simplexpointx.coords);
    _out.print(" , ");
    _out.print("" + $simplexpointx.fval);
    _out.println();
  }


  public void setcoords(List coords_x) { coords = coords_x;  }


    public void addcoords(double coords_x)
  { coords.add(new Double(coords_x)); }

  public void removecoords(double coords_x)
  { coords.remove(new Double(coords_x)); }



  

  public void setfval(double fval_x) { fval = fval_x;  }


    public static void setAllfval(List $simplexpoints,double val)
  { for (int i = 0; i < $simplexpoints.size(); i++)
    { $SimplexPoint $simplexpointx = ($SimplexPoint) $simplexpoints.get(i);
      Controller.inst().setfval($simplexpointx,val); } }


    public List getcoords() { return coords; }

  

  

    public double getfval() { return fval; }

    public static List getAllfval(List $simplexpoints)
  { List result = new Vector();
    for (int i = 0; i < $simplexpoints.size(); i++)
    { $SimplexPoint $simplexpointx = ($SimplexPoint) $simplexpoints.get(i);
      if (result.contains(new Double($simplexpointx.getfval()))) { }
      else { result.add(new Double($simplexpointx.getfval())); } }
    return result; }

    public static List getAllOrderedfval(List $simplexpoints)
  { List result = new Vector();
    for (int i = 0; i < $simplexpoints.size(); i++)
    { $SimplexPoint $simplexpointx = ($SimplexPoint) $simplexpoints.get(i);
      result.add(new Double($simplexpointx.getfval())); } 
    return result; }


}


abstract class $NFunction
  implements SystemTypes
{

  public $NFunction()
  {

  }



  public String toString()
  { String _res_ = "($NFunction) ";
    return _res_;
  }



    public abstract double apply($SimplexPoint p);




}


class $NSXFunction
  extends $NFunction
  implements SystemTypes
{

  public $NSXFunction()
  {

  }



  public String toString()
  { String _res_ = "($NSXFunction) ";
    return _res_ + super.toString();
  }

  public static $NSXFunction parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = new Vector();
    StringTokenizer _st1 =
      new StringTokenizer(_line, ",");
    while (_st1.hasMoreTokens())
    { String _str = _st1.nextToken();
      if (_str != null) 
      { _line1vals.add(_str.trim()); }
    }
    $NSXFunction $nsxfunctionx = new $NSXFunction();
    return $nsxfunctionx;
  }


  public void writeCSV(PrintWriter _out)
  { $NSXFunction $nsxfunctionx = this;
    _out.println();
  }


    public double apply($SimplexPoint p)
  {   double result = 0;
 
  double beta1 = ((Double) p.getcoords().get(0)).doubleValue(); 
     double beta2 = ((Double) p.getcoords().get(1)).doubleValue(); 
     double beta3 = ((Double) p.getcoords().get(2)).doubleValue(); 
     double lambda1 = ((Double) p.getcoords().get(3)).doubleValue(); 
     double lambda2 = ((Double) p.getcoords().get(4)).doubleValue(); 
     if (beta1 + beta2 <= 0) 
  {   result = 1000;
 
  }  else
      if (beta1 + beta2 > 0) 
  {   result = Set.sumdouble(Set.collect_37(Controller.inst().$bonds,beta1,beta2,beta3,lambda1,lambda2));
 
  }                      return result;
  }



}


class $Simplex
  implements SystemTypes
{
  private int dim = 0; // internal
  private List points = new Vector(); // of $SimplexPoint
  private $NFunction f;
  private $SimplexPoint mean;
  private $SimplexPoint reflection;

  public $Simplex($NFunction f,$SimplexPoint mean,$SimplexPoint reflection)
  {
    this.dim = 0;
    this.f = f;
    this.mean = mean;
    this.reflection = reflection;

  }

  public $Simplex() { }



  public String toString()
  { String _res_ = "($Simplex) ";
    _res_ = _res_ + dim;
    return _res_;
  }

  public static $Simplex parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = new Vector();
    StringTokenizer _st1 =
      new StringTokenizer(_line, ",");
    while (_st1.hasMoreTokens())
    { String _str = _st1.nextToken();
      if (_str != null) 
      { _line1vals.add(_str.trim()); }
    }
    $Simplex $simplexx = new $Simplex();
    $simplexx.dim = Integer.parseInt((String) _line1vals.get(0));
    return $simplexx;
  }


  public void writeCSV(PrintWriter _out)
  { $Simplex $simplexx = this;
    _out.print("" + $simplexx.dim);
    _out.println();
  }


  public void setdim(int dim_x) { dim = dim_x;  }


    public static void setAlldim(List $simplexs,int val)
  { for (int i = 0; i < $simplexs.size(); i++)
    { $Simplex $simplexx = ($Simplex) $simplexs.get(i);
      Controller.inst().setdim($simplexx,val); } }


  public void setpoints(List points_xx) { points = points_xx;
    }
 
  public void setpoints(int ind_x, $SimplexPoint points_xx) { if (ind_x >= 0 && ind_x < points.size()) { points.set(ind_x, points_xx); } }

 public void addpoints($SimplexPoint points_xx) { points.add(points_xx);
    }
 
  public void removepoints($SimplexPoint points_xx) { Vector _removedpointspoints_xx = new Vector();
  _removedpointspoints_xx.add(points_xx);
  points.removeAll(_removedpointspoints_xx);
    }

  public static void setAllpoints(List $simplexs, List _val)
  { for (int _i = 0; _i < $simplexs.size(); _i++)
    { $Simplex $simplexx = ($Simplex) $simplexs.get(_i);
      Controller.inst().setpoints($simplexx, _val); } }

  public static void setAllpoints(List $simplexs, int _ind,$SimplexPoint _val)
  { for (int _i = 0; _i < $simplexs.size(); _i++)
    { $Simplex $simplexx = ($Simplex) $simplexs.get(_i);
      Controller.inst().setpoints($simplexx,_ind,_val); } }

  public static void addAllpoints(List $simplexs, $SimplexPoint _val)
  { for (int _i = 0; _i < $simplexs.size(); _i++)
    { $Simplex $simplexx = ($Simplex) $simplexs.get(_i);
      Controller.inst().addpoints($simplexx,  _val); } }


  public static void removeAllpoints(List $simplexs,$SimplexPoint _val)
  { for (int _i = 0; _i < $simplexs.size(); _i++)
    { $Simplex $simplexx = ($Simplex) $simplexs.get(_i);
      Controller.inst().removepoints($simplexx, _val); } }


  public static void unionAllpoints(List $simplexs, List _val)
  { for (int _i = 0; _i < $simplexs.size(); _i++)
    { $Simplex $simplexx = ($Simplex) $simplexs.get(_i);
      Controller.inst().unionpoints($simplexx, _val); } }


  public static void subtractAllpoints(List $simplexs,  List _val)
  { for (int _i = 0; _i < $simplexs.size(); _i++)
    { $Simplex $simplexx = ($Simplex) $simplexs.get(_i);
      Controller.inst().subtractpoints($simplexx,  _val); } }


  public void setf($NFunction f_xx) { f = f_xx;
  }

  public static void setAllf(List $simplexs, $NFunction _val)
  { for (int _i = 0; _i < $simplexs.size(); _i++)
    { $Simplex $simplexx = ($Simplex) $simplexs.get(_i);
      Controller.inst().setf($simplexx, _val); } }

  public void setmean($SimplexPoint mean_xx) { mean = mean_xx;
  }

  public static void setAllmean(List $simplexs, $SimplexPoint _val)
  { for (int _i = 0; _i < $simplexs.size(); _i++)
    { $Simplex $simplexx = ($Simplex) $simplexs.get(_i);
      Controller.inst().setmean($simplexx, _val); } }

  public void setreflection($SimplexPoint reflection_xx) { reflection = reflection_xx;
  }

  public static void setAllreflection(List $simplexs, $SimplexPoint _val)
  { for (int _i = 0; _i < $simplexs.size(); _i++)
    { $Simplex $simplexx = ($Simplex) $simplexs.get(_i);
      Controller.inst().setreflection($simplexx, _val); } }

    public int getdim() { return dim; }

    public static List getAlldim(List $simplexs)
  { List result = new Vector();
    for (int i = 0; i < $simplexs.size(); i++)
    { $Simplex $simplexx = ($Simplex) $simplexs.get(i);
      if (result.contains(new Integer($simplexx.getdim()))) { }
      else { result.add(new Integer($simplexx.getdim())); } }
    return result; }

    public static List getAllOrdereddim(List $simplexs)
  { List result = new Vector();
    for (int i = 0; i < $simplexs.size(); i++)
    { $Simplex $simplexx = ($Simplex) $simplexs.get(i);
      result.add(new Integer($simplexx.getdim())); } 
    return result; }

  public List getpoints() { return (Vector) ((Vector) points).clone(); }

  public static List getAllpoints(List $simplexs)
  { List result = new Vector();
    for (int _i = 0; _i < $simplexs.size(); _i++)
    { $Simplex $simplexx = ($Simplex) $simplexs.get(_i);
      result = Set.union(result, $simplexx.getpoints()); }
    return result; }

  public static List getAllOrderedpoints(List $simplexs)
  { List result = new Vector();
    for (int _i = 0; _i < $simplexs.size(); _i++)
    { $Simplex $simplexx = ($Simplex) $simplexs.get(_i);
      result.addAll($simplexx.getpoints()); }
    return result; }

  public $NFunction getf() { return f; }

  public static List getAllf(List $simplexs)
  { List result = new Vector();
    for (int _i = 0; _i < $simplexs.size(); _i++)
    { $Simplex $simplexx = ($Simplex) $simplexs.get(_i);
      if (result.contains($simplexx.getf())) {}
      else { result.add($simplexx.getf()); }
 }
    return result; }

  public static List getAllOrderedf(List $simplexs)
  { List result = new Vector();
    for (int _i = 0; _i < $simplexs.size(); _i++)
    { $Simplex $simplexx = ($Simplex) $simplexs.get(_i);
      if (result.contains($simplexx.getf())) {}
      else { result.add($simplexx.getf()); }
 }
    return result; }

  public $SimplexPoint getmean() { return mean; }

  public static List getAllmean(List $simplexs)
  { List result = new Vector();
    for (int _i = 0; _i < $simplexs.size(); _i++)
    { $Simplex $simplexx = ($Simplex) $simplexs.get(_i);
      if (result.contains($simplexx.getmean())) {}
      else { result.add($simplexx.getmean()); }
 }
    return result; }

  public static List getAllOrderedmean(List $simplexs)
  { List result = new Vector();
    for (int _i = 0; _i < $simplexs.size(); _i++)
    { $Simplex $simplexx = ($Simplex) $simplexs.get(_i);
      if (result.contains($simplexx.getmean())) {}
      else { result.add($simplexx.getmean()); }
 }
    return result; }

  public $SimplexPoint getreflection() { return reflection; }

  public static List getAllreflection(List $simplexs)
  { List result = new Vector();
    for (int _i = 0; _i < $simplexs.size(); _i++)
    { $Simplex $simplexx = ($Simplex) $simplexs.get(_i);
      if (result.contains($simplexx.getreflection())) {}
      else { result.add($simplexx.getreflection()); }
 }
    return result; }

  public static List getAllOrderedreflection(List $simplexs)
  { List result = new Vector();
    for (int _i = 0; _i < $simplexs.size(); _i++)
    { $Simplex $simplexx = ($Simplex) $simplexs.get(_i);
      if (result.contains($simplexx.getreflection())) {}
      else { result.add($simplexx.getreflection()); }
 }
    return result; }

    public boolean sortPoints()
  {   boolean result = false;
    List pre_points22 = new Vector();
    pre_points22.addAll(points);
Controller.inst().setpoints(this,Set.sortedBy(pre_points22, Set.collect_38(pre_points22)));
    result = true;
  return result;

  }

    public double diameter()
  {   double result = 0;
 
  result = $Sequences.distance((($SimplexPoint) Set.first(points)).getcoords(),(($SimplexPoint) Set.last(points)).getcoords());
    return result;
  }


    public void initialise($SimplexPoint x)
  { Controller.inst().addpoints(this,x);
    Controller.inst().setdim(this,x.getcoords().size());
        List _int_list23 = new Vector();
    _int_list23.addAll(Set.integerSubrange(1,this.getdim()));
    for (int _ind24 = 0; _ind24 < _int_list23.size(); _ind24++)
    { int i = ((Integer) _int_list23.get(_ind24)).intValue();
      $SimplexPoint p = new $SimplexPoint();
    Controller.inst().add$SimplexPoint(p);
    Controller.inst().setcoords(p,( Set.concatenate(Set.subrange(x.getcoords(),1,i - 1),Set.concatenate((new SystemTypes.Set()).add(new Double(((Double) x.getcoords().get(i - 1)).doubleValue() * 1.05)).getElements(),Set.subrange(x.getcoords(),i + 1,this.getdim()))) ));
    Controller.inst().addpoints(this,p);
    }

        List _$simplexpoint_list25 = new Vector();
    _$simplexpoint_list25.addAll(this.getpoints());
    for (int _ind26 = 0; _ind26 < _$simplexpoint_list25.size(); _ind26++)
    { $SimplexPoint p = ($SimplexPoint) _$simplexpoint_list25.get(_ind26);
      Controller.inst().setfval(p,this.getf().apply(p));
    }

  }

    public void computeMeanReflection()
  { $SimplexPoint m = new $SimplexPoint();
    Controller.inst().add$SimplexPoint(m);
    Controller.inst().setcoords(m,$Sequences.sqAverage(Set.collect_39(Set.front(this.getpoints()))));
    Controller.inst().setfval(m,this.getf().apply(m));
    Controller.inst().setmean(this,m);
    $SimplexPoint r = new $SimplexPoint();
    Controller.inst().add$SimplexPoint(r);
    Controller.inst().setcoords(r,$Sequences.ssSubtract($Sequences.sqMult(this.getmean().getcoords(),2.0),(($SimplexPoint) Set.last(this.getpoints())).getcoords()));
    Controller.inst().setfval(r,this.getf().apply(r));
    Controller.inst().setreflection(this,r);
  }

    public void expand()
  { $SimplexPoint s = new $SimplexPoint();
    Controller.inst().add$SimplexPoint(s);
    Controller.inst().setcoords(s,$Sequences.ssAdd(this.getmean().getcoords(),$Sequences.sqMult($Sequences.ssSubtract(this.getmean().getcoords(),(($SimplexPoint) Set.last(this.getpoints())).getcoords()),2.0)));
    Controller.inst().setfval(s,this.getf().apply(s));
      if (s.getfval() < this.getreflection().getfval()) 
  { Controller.inst().setpoints(this,( this.getdim() + 1 ) - 1,s);}
      if (this.getreflection().getfval() <= s.getfval()) 
  { Controller.inst().setpoints(this,( this.getdim() + 1 ) - 1,this.getreflection());}
  }

    public void shrink($SimplexPoint x1)
  {     List _int_list27 = new Vector();
    _int_list27.addAll(Set.integerSubrange(2,this.getdim() + 1));
    for (int _ind28 = 0; _ind28 < _int_list27.size(); _ind28++)
    { int i = ((Integer) _int_list27.get(_ind28)).intValue();
      Controller.inst().setcoords((($SimplexPoint) this.getpoints().get(i - 1)),$Sequences.ssAdd(x1.getcoords(),$Sequences.sqMult($Sequences.ssSubtract((($SimplexPoint) this.getpoints().get(i - 1)).getcoords(),x1.getcoords()),0.5)));
    Controller.inst().setfval((($SimplexPoint) this.getpoints().get(i - 1)),this.getf().apply((($SimplexPoint) this.getpoints().get(i - 1))));
    }

  }

    public void contractInside($SimplexPoint c)
  {   if (c.getfval() < this.getreflection().getfval()) 
  { Controller.inst().setpoints(this,( this.getdim() + 1 ) - 1,c);}
      if (this.getreflection().getfval() <= c.getfval()) 
  { this.shrink((($SimplexPoint) Set.first(this.getpoints())));}
  }

    public void contractOutside($SimplexPoint cc)
  {   if (cc.getfval() < (($SimplexPoint) Set.last(this.getpoints())).getfval()) 
  { Controller.inst().setpoints(this,( this.getdim() + 1 ) - 1,cc);}
      if ((($SimplexPoint) Set.last(this.getpoints())).getfval() <= cc.getfval()) 
  { this.shrink((($SimplexPoint) Set.first(this.getpoints())));}
  }

    public void contract()
  {   if (this.getreflection().getfval() < (($SimplexPoint) Set.last(this.getpoints())).getfval()) 
  { $SimplexPoint c = new $SimplexPoint();
    Controller.inst().add$SimplexPoint(c);
    Controller.inst().setcoords(c,$Sequences.ssAdd(this.getmean().getcoords(),$Sequences.sqMult($Sequences.ssSubtract(this.getreflection().getcoords(),this.getmean().getcoords()),0.5)));
    Controller.inst().setfval(c,this.getf().apply(c));
    this.contractInside(c);}
      if (this.getreflection().getfval() >= (($SimplexPoint) Set.last(this.getpoints())).getfval()) 
  { $SimplexPoint cc = new $SimplexPoint();
    Controller.inst().add$SimplexPoint(cc);
    Controller.inst().setcoords(cc,$Sequences.ssAdd(this.getmean().getcoords(),$Sequences.sqMult($Sequences.ssSubtract((($SimplexPoint) Set.last(this.getpoints())).getcoords(),this.getmean().getcoords()),0.5)));
    Controller.inst().setfval(cc,this.getf().apply(cc));
    this.contractOutside(cc);}
  }

    public void reflectExpand()
  {   if ((($SimplexPoint) Set.first(this.getpoints())).getfval() <= this.getreflection().getfval() && this.getreflection().getfval() < (($SimplexPoint) this.getpoints().get(this.getdim() - 1)).getfval()) 
  { Controller.inst().setpoints(this,( this.getdim() + 1 ) - 1,this.getreflection());}
      if (this.getreflection().getfval() < (($SimplexPoint) Set.first(this.getpoints())).getfval()) 
  { this.expand();}
      if ((($SimplexPoint) this.getpoints().get(this.getdim() - 1)).getfval() <= this.getreflection().getfval()) 
  { this.contract();}
  }

    public $SimplexPoint iterate($SimplexPoint x,double tol)
  {  $SimplexPoint result;
$Simplex $simplexx = this;
     $simplexx.initialise(x);
    $simplexx.sortPoints();
    while ($simplexx.diameter() > tol) 
  {    $simplexx.computeMeanReflection();
    $simplexx.reflectExpand();
    $simplexx.sortPoints();
      System.out.println("" + (($SimplexPoint) $simplexx.getpoints().get(0)));

      System.out.println("" + $simplexx.diameter());
 }
    return (($SimplexPoint) $simplexx.getpoints().get(0));


  }



}


class Points
  extends ExcelLib
  implements SystemTypes
{
  private double X = 1.2; // internal
  private double Y = 2.6; // internal

  public Points()
  {
    this.X = 1.2;
    this.Y = 2.6;

  }



  public String toString()
  { String _res_ = "(Points) ";
    _res_ = _res_ + X + ",";
    _res_ = _res_ + Y;
    return _res_ + super.toString();
  }

  public static Points parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = new Vector();
    StringTokenizer _st1 =
      new StringTokenizer(_line, ",");
    while (_st1.hasMoreTokens())
    { String _str = _st1.nextToken();
      if (_str != null) 
      { _line1vals.add(_str.trim()); }
    }
    Points pointsx = new Points();
    pointsx.X = Double.parseDouble((String) _line1vals.get(0));
    pointsx.Y = Double.parseDouble((String) _line1vals.get(1));
    return pointsx;
  }


  public void writeCSV(PrintWriter _out)
  { Points pointsx = this;
    _out.print("" + pointsx.X);
    _out.print(" , ");
    _out.print("" + pointsx.Y);
    _out.println();
  }


  public void setX(double X_x) { X = X_x;  }


    public static void setAllX(List pointss,double val)
  { for (int i = 0; i < pointss.size(); i++)
    { Points pointsx = (Points) pointss.get(i);
      Controller.inst().setX(pointsx,val); } }


  public void setY(double Y_x) { Y = Y_x;  }


    public static void setAllY(List pointss,double val)
  { for (int i = 0; i < pointss.size(); i++)
    { Points pointsx = (Points) pointss.get(i);
      Controller.inst().setY(pointsx,val); } }


    public double getX() { return X; }

    public static List getAllX(List pointss)
  { List result = new Vector();
    for (int i = 0; i < pointss.size(); i++)
    { Points pointsx = (Points) pointss.get(i);
      if (result.contains(new Double(pointsx.getX()))) { }
      else { result.add(new Double(pointsx.getX())); } }
    return result; }

    public static List getAllOrderedX(List pointss)
  { List result = new Vector();
    for (int i = 0; i < pointss.size(); i++)
    { Points pointsx = (Points) pointss.get(i);
      result.add(new Double(pointsx.getX())); } 
    return result; }

    public double getY() { return Y; }

    public static List getAllY(List pointss)
  { List result = new Vector();
    for (int i = 0; i < pointss.size(); i++)
    { Points pointsx = (Points) pointss.get(i);
      if (result.contains(new Double(pointsx.getY()))) { }
      else { result.add(new Double(pointsx.getY())); } }
    return result; }

    public static List getAllOrderedY(List pointss)
  { List result = new Vector();
    for (int i = 0; i < pointss.size(); i++)
    { Points pointsx = (Points) pointss.get(i);
      result.add(new Double(pointsx.getY())); } 
    return result; }


}


class ResultTable
  extends ExcelLib
  implements SystemTypes
{
  private double Diff = 0; // internal

  public ResultTable()
  {
    this.Diff = 0;

  }



  public String toString()
  { String _res_ = "(ResultTable) ";
    _res_ = _res_ + Diff;
    return _res_ + super.toString();
  }

  public static ResultTable parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = new Vector();
    StringTokenizer _st1 =
      new StringTokenizer(_line, ",");
    while (_st1.hasMoreTokens())
    { String _str = _st1.nextToken();
      if (_str != null) 
      { _line1vals.add(_str.trim()); }
    }
    ResultTable resulttablex = new ResultTable();
    resulttablex.Diff = Double.parseDouble((String) _line1vals.get(0));
    return resulttablex;
  }


  public void writeCSV(PrintWriter _out)
  { ResultTable resulttablex = this;
    _out.print("" + resulttablex.Diff);
    _out.println();
  }


  public void setDiff(double Diff_x) { Diff = Diff_x;  }


    public static void setAllDiff(List resulttables,double val)
  { for (int i = 0; i < resulttables.size(); i++)
    { ResultTable resulttablex = (ResultTable) resulttables.get(i);
      Controller.inst().setDiff(resulttablex,val); } }


    public double getDiff() { return Diff; }

    public static List getAllDiff(List resulttables)
  { List result = new Vector();
    for (int i = 0; i < resulttables.size(); i++)
    { ResultTable resulttablex = (ResultTable) resulttables.get(i);
      if (result.contains(new Double(resulttablex.getDiff()))) { }
      else { result.add(new Double(resulttablex.getDiff())); } }
    return result; }

    public static List getAllOrderedDiff(List resulttables)
  { List result = new Vector();
    for (int i = 0; i < resulttables.size(); i++)
    { ResultTable resulttablex = (ResultTable) resulttables.get(i);
      result.add(new Double(resulttablex.getDiff())); } 
    return result; }


}


class Sheet
  implements SystemTypes
{

  public Sheet()
  {

  }



  public String toString()
  { String _res_ = "(Sheet) ";
    return _res_;
  }

  public static Sheet parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = new Vector();
    StringTokenizer _st1 =
      new StringTokenizer(_line, ",");
    while (_st1.hasMoreTokens())
    { String _str = _st1.nextToken();
      if (_str != null) 
      { _line1vals.add(_str.trim()); }
    }
    Sheet sheetx = new Sheet();
    return sheetx;
  }


  public void writeCSV(PrintWriter _out)
  { Sheet sheetx = this;
    _out.println();
  }


  


}



public class Controller implements SystemTypes, ControllerInterface
{
  Vector excellibs = new Vector();
  Vector applications = new Vector();
  Vector $bonds = new Vector();
  Vector $bondgroups = new Vector();
  Vector $cashflows = new Vector();
  Vector nelsonseigals = new Vector();
  Vector $gaindividuals = new Vector();
  Vector $gatraits = new Vector();
  Vector $geneticalgorithms = new Vector();
  Vector $sequencess = new Vector();
  Vector $matrixs = new Vector();
  Vector initialisensxs = new Vector();
  Vector $simplexpoints = new Vector();
  Vector $nfunctions = new Vector();
  Vector $nsxfunctions = new Vector();
  Vector $simplexs = new Vector();
  Vector pointss = new Vector();
  Vector resulttables = new Vector();
  Vector sheets = new Vector();
  private static Controller uniqueInstance; 


  private Controller() { } 


  public static Controller inst() 
    { if (uniqueInstance == null) 
    { uniqueInstance = new Controller(); }
    return uniqueInstance; } 


  public static void loadModel(String file)
  {
    try
    { BufferedReader br = null;
      File f = new File(file);
      try 
      { br = new BufferedReader(new FileReader(f)); }
      catch (Exception ex) 
      { System.err.println("No file: " + file); return; }
      Class cont = Class.forName("Controller");
      java.util.Map objectmap = new java.util.HashMap();
      while (true)
      { String line1;
        try { line1 = br.readLine(); }
        catch (Exception e)
        { return; }
        if (line1 == null)
        { return; }
        line1 = line1.trim();

        if (line1.length() == 0) { continue; }
        String left;
        String op;
        String right;
        if (line1.charAt(line1.length() - 1) == '"')
        { int eqind = line1.indexOf("="); 
          if (eqind == -1) { continue; }
          else 
          { left = line1.substring(0,eqind-1).trim();
            op = "="; 
            right = line1.substring(eqind+1,line1.length()).trim();
          }
        }
        else
        { StringTokenizer st1 = new StringTokenizer(line1);
          Vector vals1 = new Vector();
          while (st1.hasMoreTokens())
          { String val1 = st1.nextToken();
            vals1.add(val1);
          }
          if (vals1.size() < 3)
          { continue; }
          left = (String) vals1.get(0);
          op = (String) vals1.get(1);
          right = (String) vals1.get(2);
        }
        if (":".equals(op))
        { int i2 = right.indexOf(".");
          if (i2 == -1)
          { Class cl;
            try { cl = Class.forName("" + right); }
            catch (Exception _x) { System.err.println("No entity: " + right); continue; }
            Object xinst = cl.newInstance();
            objectmap.put(left,xinst);
            Class[] cargs = new Class[] { cl };
            Method addC = null;
            try { addC = cont.getMethod("add" + right,cargs); }
            catch (Exception _xx) { System.err.println("No entity: " + right); continue; }
            if (addC == null) { continue; }
            Object[] args = new Object[] { xinst };
            addC.invoke(Controller.inst(),args);
          }
          else
          { String obj = right.substring(0,i2);
            String role = right.substring(i2+1,right.length());
            Object objinst = objectmap.get(obj); 
            if (objinst == null) 
            { continue; }
            Object val = objectmap.get(left);
            if (val == null) 
            { continue; }
            Class objC = objinst.getClass();
            Class typeclass = val.getClass(); 
            Object[] args = new Object[] { val }; 
            Class[] settypes = new Class[] { typeclass };
            Method addrole = Controller.findMethod(objC,"add" + role);
            if (addrole != null) 
            { addrole.invoke(objinst, args); }
            else { System.err.println("Error: cannot add to " + role); }
          }
        }
        else if ("=".equals(op))
        { int i1 = left.indexOf(".");
          if (i1 == -1) 
          { continue; }
          String obj = left.substring(0,i1);
          String att = left.substring(i1+1,left.length());
          Object objinst = objectmap.get(obj); 
          if (objinst == null) 
          { continue; }
          Class objC = objinst.getClass();
          Class typeclass; 
          Object val; 
          if (right.charAt(0) == '"' &&
              right.charAt(right.length() - 1) == '"')
          { typeclass = String.class;
            val = right.substring(1,right.length() - 1);
          } 
          else if ("true".equals(right) || "false".equals(right))
          { typeclass = boolean.class;
            if ("true".equals(right))
            { val = new Boolean(true); }
            else
            { val = new Boolean(false); }
          }
          else 
          { val = objectmap.get(right);
            if (val != null)
            { typeclass = val.getClass(); }
            else 
            { int i;
              long l; 
              double d;
              try 
              { i = Integer.parseInt(right);
                typeclass = int.class;
                val = new Integer(i); 
              }
              catch (Exception ee)
              { try 
                { l = Long.parseLong(right);
                  typeclass = long.class;
                  val = new Long(l); 
                }
                catch (Exception eee)
                { try
                  { d = Double.parseDouble(right);
                    typeclass = double.class;
                    val = new Double(d);
                  }
                  catch (Exception ff)
                  { continue; }
                }
              }
            }
          }
          Object[] args = new Object[] { val }; 
          Class[] settypes = new Class[] { typeclass };
          Method setatt = Controller.findMethod(objC,"set" + att);
          if (setatt != null) 
          { setatt.invoke(objinst, args); }
          else { System.err.println("No attribute: " + objC.getName() + "::" + att); }
        }
      }
    } catch (Exception e) { }
  }

  public static Method findMethod(Class c, String name)
  { Method[] mets = c.getMethods(); 
    for (int i = 0; i < mets.length; i++)
    { Method m = mets[i];
      if (m.getName().equals(name))
      { return m; }
    } 
    return null;
  }


  public static void loadCSVModel()
  { boolean __eof = false;
    String __s = "";
    Controller __cont = Controller.inst();
    BufferedReader __br = null;
    try
    { File _nelsonseigal = new File("NelsonSeigal.csv");
      __br = new BufferedReader(new FileReader(_nelsonseigal));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { NelsonSeigal nelsonseigalx = NelsonSeigal.parseCSV(__s.trim());
          if (nelsonseigalx != null)
          { __cont.addNelsonSeigal(nelsonseigalx); }
        }
      }
    }
    catch(Exception __e) { }
    try
    { File _initialisensx = new File("Initialisensx.csv");
      __br = new BufferedReader(new FileReader(_initialisensx));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { Initialisensx initialisensxx = Initialisensx.parseCSV(__s.trim());
          if (initialisensxx != null)
          { __cont.addInitialisensx(initialisensxx); }
        }
      }
    }
    catch(Exception __e) { }
    try
    { File _points = new File("Points.csv");
      __br = new BufferedReader(new FileReader(_points));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { Points pointsx = Points.parseCSV(__s.trim());
          if (pointsx != null)
          { __cont.addPoints(pointsx); }
        }
      }
    }
    catch(Exception __e) { }
    try
    { File _resulttable = new File("ResultTable.csv");
      __br = new BufferedReader(new FileReader(_resulttable));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { ResultTable resulttablex = ResultTable.parseCSV(__s.trim());
          if (resulttablex != null)
          { __cont.addResultTable(resulttablex); }
        }
      }
    }
    catch(Exception __e) { }
    try
    { File _sheet = new File("Sheet.csv");
      __br = new BufferedReader(new FileReader(_sheet));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { Sheet sheetx = Sheet.parseCSV(__s.trim());
          if (sheetx != null)
          { __cont.addSheet(sheetx); }
        }
      }
    }
    catch(Exception __e) { }
  }


  public void checkCompleteness()
  {   }


  public void saveModel(String file)
  { File outfile = new File(file); 
    PrintWriter out; 
    try { out = new PrintWriter(new BufferedWriter(new FileWriter(outfile))); }
    catch (Exception e) { return; } 
  for (int _i = 0; _i < applications.size(); _i++)
  { Application applicationx_ = (Application) applications.get(_i);
    out.println("applicationx_" + _i + " : Application");
  }

  for (int _i = 0; _i < $bonds.size(); _i++)
  { $Bond $bondx_ = ($Bond) $bonds.get(_i);
    out.println("$bondx_" + _i + " : $Bond");
    out.println("$bondx_" + _i + ".price = " + $bondx_.getprice());
    out.println("$bondx_" + _i + ".coupon = " + $bondx_.getcoupon());
    out.println("$bondx_" + _i + ".frequency = " + $bondx_.getfrequency());
    out.println("$bondx_" + _i + ".period = " + $bondx_.getperiod());
    out.println("$bondx_" + _i + ".maturity = " + $bondx_.getmaturity());
    out.println("$bondx_" + _i + ".yield = " + $bondx_.getyield());
    out.println("$bondx_" + _i + ".duration = " + $bondx_.getduration());
    out.println("$bondx_" + _i + ".weight = " + $bondx_.getweight());
    out.println("$bondx_" + _i + ".redemption = " + $bondx_.getredemption());
  }

  for (int _i = 0; _i < $bondgroups.size(); _i++)
  { $BondGroup $bondgroupx_ = ($BondGroup) $bondgroups.get(_i);
    out.println("$bondgroupx_" + _i + " : $BondGroup");
    out.println("$bondgroupx_" + _i + ".inverseDsum = " + $bondgroupx_.getinverseDsum());
  }

  for (int _i = 0; _i < $cashflows.size(); _i++)
  { $CashFlow $cashflowx_ = ($CashFlow) $cashflows.get(_i);
    out.println("$cashflowx_" + _i + " : $CashFlow");
    out.println("$cashflowx_" + _i + ".amount = " + $cashflowx_.getamount());
    out.println("$cashflowx_" + _i + ".timePoint = " + $cashflowx_.gettimePoint());
    out.println("$cashflowx_" + _i + ".rate = " + $cashflowx_.getrate());
    out.println("$cashflowx_" + _i + ".discount = " + $cashflowx_.getdiscount());
  }

  for (int _i = 0; _i < nelsonseigals.size(); _i++)
  { NelsonSeigal nelsonseigalx_ = (NelsonSeigal) nelsonseigals.get(_i);
    out.println("nelsonseigalx_" + _i + " : NelsonSeigal");
    out.println("nelsonseigalx_" + _i + ".beta1 = " + nelsonseigalx_.getbeta1());
    out.println("nelsonseigalx_" + _i + ".beta2 = " + nelsonseigalx_.getbeta2());
    out.println("nelsonseigalx_" + _i + ".beta3 = " + nelsonseigalx_.getbeta3());
    out.println("nelsonseigalx_" + _i + ".lambda1 = " + nelsonseigalx_.getlambda1());
    out.println("nelsonseigalx_" + _i + ".lambda2 = " + nelsonseigalx_.getlambda2());
  }

  for (int _i = 0; _i < $gaindividuals.size(); _i++)
  { $GAIndividual $gaindividualx_ = ($GAIndividual) $gaindividuals.get(_i);
    out.println("$gaindividualx_" + _i + " : $GAIndividual");
    out.println("$gaindividualx_" + _i + ".fitnessval = " + $gaindividualx_.getfitnessval());
  }

  for (int _i = 0; _i < $gatraits.size(); _i++)
  { $GATrait $gatraitx_ = ($GATrait) $gatraits.get(_i);
    out.println("$gatraitx_" + _i + " : $GATrait");
    out.println("$gatraitx_" + _i + ".item = \"" + $gatraitx_.getitem() + "\"");
    out.println("$gatraitx_" + _i + ".value = " + $gatraitx_.getvalue());
  }

  for (int _i = 0; _i < $geneticalgorithms.size(); _i++)
  { $GeneticAlgorithm $geneticalgorithmx_ = ($GeneticAlgorithm) $geneticalgorithms.get(_i);
    out.println("$geneticalgorithmx_" + _i + " : $GeneticAlgorithm");
    out.println("$geneticalgorithmx_" + _i + ".maxfitness = " + $geneticalgorithmx_.getmaxfitness());
  }

  for (int _i = 0; _i < $sequencess.size(); _i++)
  { $Sequences $sequencesx_ = ($Sequences) $sequencess.get(_i);
    out.println("$sequencesx_" + _i + " : $Sequences");
  }

  for (int _i = 0; _i < $matrixs.size(); _i++)
  { $Matrix $matrixx_ = ($Matrix) $matrixs.get(_i);
    out.println("$matrixx_" + _i + " : $Matrix");
  }

  for (int _i = 0; _i < initialisensxs.size(); _i++)
  { Initialisensx initialisensxx_ = (Initialisensx) initialisensxs.get(_i);
    out.println("initialisensxx_" + _i + " : Initialisensx");
  }

  for (int _i = 0; _i < $simplexpoints.size(); _i++)
  { $SimplexPoint $simplexpointx_ = ($SimplexPoint) $simplexpoints.get(_i);
    out.println("$simplexpointx_" + _i + " : $SimplexPoint");
    List $simplexpoint_coords = $simplexpointx_.getcoords();
    for (int _j = 0; _j < $simplexpoint_coords.size(); _j++)
    { out.println($simplexpoint_coords.get(_j) + " : $simplexpointx_" + _i + ".coords");
    }
    out.println("$simplexpointx_" + _i + ".fval = " + $simplexpointx_.getfval());
  }

  for (int _i = 0; _i < $nsxfunctions.size(); _i++)
  { $NSXFunction $nsxfunctionx_ = ($NSXFunction) $nsxfunctions.get(_i);
    out.println("$nsxfunctionx_" + _i + " : $NSXFunction");
  }

  for (int _i = 0; _i < $simplexs.size(); _i++)
  { $Simplex $simplexx_ = ($Simplex) $simplexs.get(_i);
    out.println("$simplexx_" + _i + " : $Simplex");
    out.println("$simplexx_" + _i + ".dim = " + $simplexx_.getdim());
  }

  for (int _i = 0; _i < pointss.size(); _i++)
  { Points pointsx_ = (Points) pointss.get(_i);
    out.println("pointsx_" + _i + " : Points");
    out.println("pointsx_" + _i + ".X = " + pointsx_.getX());
    out.println("pointsx_" + _i + ".Y = " + pointsx_.getY());
  }

  for (int _i = 0; _i < resulttables.size(); _i++)
  { ResultTable resulttablex_ = (ResultTable) resulttables.get(_i);
    out.println("resulttablex_" + _i + " : ResultTable");
    out.println("resulttablex_" + _i + ".Diff = " + resulttablex_.getDiff());
  }

  for (int _i = 0; _i < sheets.size(); _i++)
  { Sheet sheetx_ = (Sheet) sheets.get(_i);
    out.println("sheetx_" + _i + " : Sheet");
  }

  for (int _i = 0; _i < $bonds.size(); _i++)
  { $Bond $bondx_ = ($Bond) $bonds.get(_i);
    List $bond_flows_$CashFlow = $bondx_.getflows();
    for (int _j = 0; _j < $bond_flows_$CashFlow.size(); _j++)
    { out.println("$cashflowx_" + $cashflows.indexOf($bond_flows_$CashFlow.get(_j)) + " : $bondx_" + _i + ".flows");
    }
  }
  for (int _i = 0; _i < $bondgroups.size(); _i++)
  { $BondGroup $bondgroupx_ = ($BondGroup) $bondgroups.get(_i);
    List $bondgroup_bonds_$Bond = $bondgroupx_.getbonds();
    for (int _j = 0; _j < $bondgroup_bonds_$Bond.size(); _j++)
    { out.println("$bondx_" + $bonds.indexOf($bondgroup_bonds_$Bond.get(_j)) + " : $bondgroupx_" + _i + ".bonds");
    }
  }
  for (int _i = 0; _i < $gaindividuals.size(); _i++)
  { $GAIndividual $gaindividualx_ = ($GAIndividual) $gaindividuals.get(_i);
    List $gaindividual_traits_$GATrait = $gaindividualx_.gettraits();
    for (int _j = 0; _j < $gaindividual_traits_$GATrait.size(); _j++)
    { out.println("$gatraitx_" + $gatraits.indexOf($gaindividual_traits_$GATrait.get(_j)) + " : $gaindividualx_" + _i + ".traits");
    }
  }
  for (int _i = 0; _i < $geneticalgorithms.size(); _i++)
  { $GeneticAlgorithm $geneticalgorithmx_ = ($GeneticAlgorithm) $geneticalgorithms.get(_i);
    List $geneticalgorithm_population_$GAIndividual = $geneticalgorithmx_.getpopulation();
    for (int _j = 0; _j < $geneticalgorithm_population_$GAIndividual.size(); _j++)
    { out.println("$gaindividualx_" + $gaindividuals.indexOf($geneticalgorithm_population_$GAIndividual.get(_j)) + " : $geneticalgorithmx_" + _i + ".population");
    }
  }
  for (int _i = 0; _i < $simplexs.size(); _i++)
  { $Simplex $simplexx_ = ($Simplex) $simplexs.get(_i);
    List $simplex_points_$SimplexPoint = $simplexx_.getpoints();
    for (int _j = 0; _j < $simplex_points_$SimplexPoint.size(); _j++)
    { out.println("$simplexpointx_" + $simplexpoints.indexOf($simplex_points_$SimplexPoint.get(_j)) + " : $simplexx_" + _i + ".points");
    }
    if ($simplexx_.getf() instanceof $NSXFunction)
    { out.println("$simplexx_" + _i + ".f = $nsxfunctionx_" + $nsxfunctions.indexOf($simplexx_.getf())); } 
    out.println("$simplexx_" + _i + ".mean = $simplexpointx_" + $simplexpoints.indexOf((($Simplex) $simplexs.get(_i)).getmean()));
    out.println("$simplexx_" + _i + ".reflection = $simplexpointx_" + $simplexpoints.indexOf((($Simplex) $simplexs.get(_i)).getreflection()));
  }
    out.close(); 
  }


  public void saveXSI(String file)
  { File outfile = new File(file); 
    PrintWriter out; 
    try { out = new PrintWriter(new BufferedWriter(new FileWriter(outfile))); }
    catch (Exception e) { return; } 
    out.println("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
    out.println("<My:model xmi:version=\"2.0\" xmlns:xmi=\"http://www.omg.org/XMI\">");
    for (int _i = 0; _i < applications.size(); _i++)
    { Application applicationx_ = (Application) applications.get(_i);
       out.print("<applications xsi:type=\"My:Application\"");
    out.println(" />");
  }

    for (int _i = 0; _i < $bonds.size(); _i++)
    { $Bond $bondx_ = ($Bond) $bonds.get(_i);
       out.print("<$bonds xsi:type=\"My:$Bond\"");
    out.print(" price=\"" + $bondx_.getprice() + "\" ");
    out.print(" coupon=\"" + $bondx_.getcoupon() + "\" ");
    out.print(" frequency=\"" + $bondx_.getfrequency() + "\" ");
    out.print(" period=\"" + $bondx_.getperiod() + "\" ");
    out.print(" maturity=\"" + $bondx_.getmaturity() + "\" ");
    out.print(" yield=\"" + $bondx_.getyield() + "\" ");
    out.print(" duration=\"" + $bondx_.getduration() + "\" ");
    out.print(" weight=\"" + $bondx_.getweight() + "\" ");
    out.print(" redemption=\"" + $bondx_.getredemption() + "\" ");
    out.print(" flows = \"");
    List $bond_flows = $bondx_.getflows();
    for (int _j = 0; _j < $bond_flows.size(); _j++)
    { out.print(" //@$cashflows." + $cashflows.indexOf($bond_flows.get(_j)));
    }
    out.print("\"");
    out.println(" />");
  }

    for (int _i = 0; _i < $bondgroups.size(); _i++)
    { $BondGroup $bondgroupx_ = ($BondGroup) $bondgroups.get(_i);
       out.print("<$bondgroups xsi:type=\"My:$BondGroup\"");
    out.print(" inverseDsum=\"" + $bondgroupx_.getinverseDsum() + "\" ");
    out.print(" bonds = \"");
    List $bondgroup_bonds = $bondgroupx_.getbonds();
    for (int _j = 0; _j < $bondgroup_bonds.size(); _j++)
    { out.print(" //@$bonds." + $bonds.indexOf($bondgroup_bonds.get(_j)));
    }
    out.print("\"");
    out.println(" />");
  }

    for (int _i = 0; _i < $cashflows.size(); _i++)
    { $CashFlow $cashflowx_ = ($CashFlow) $cashflows.get(_i);
       out.print("<$cashflows xsi:type=\"My:$CashFlow\"");
    out.print(" amount=\"" + $cashflowx_.getamount() + "\" ");
    out.print(" timePoint=\"" + $cashflowx_.gettimePoint() + "\" ");
    out.print(" rate=\"" + $cashflowx_.getrate() + "\" ");
    out.print(" discount=\"" + $cashflowx_.getdiscount() + "\" ");
    out.println(" />");
  }

    for (int _i = 0; _i < nelsonseigals.size(); _i++)
    { NelsonSeigal nelsonseigalx_ = (NelsonSeigal) nelsonseigals.get(_i);
       out.print("<nelsonseigals xsi:type=\"My:NelsonSeigal\"");
    out.print(" beta1=\"" + nelsonseigalx_.getbeta1() + "\" ");
    out.print(" beta2=\"" + nelsonseigalx_.getbeta2() + "\" ");
    out.print(" beta3=\"" + nelsonseigalx_.getbeta3() + "\" ");
    out.print(" lambda1=\"" + nelsonseigalx_.getlambda1() + "\" ");
    out.print(" lambda2=\"" + nelsonseigalx_.getlambda2() + "\" ");
    out.println(" />");
  }

    for (int _i = 0; _i < $gaindividuals.size(); _i++)
    { $GAIndividual $gaindividualx_ = ($GAIndividual) $gaindividuals.get(_i);
       out.print("<$gaindividuals xsi:type=\"My:$GAIndividual\"");
    out.print(" fitnessval=\"" + $gaindividualx_.getfitnessval() + "\" ");
    out.print(" traits = \"");
    List $gaindividual_traits = $gaindividualx_.gettraits();
    for (int _j = 0; _j < $gaindividual_traits.size(); _j++)
    { out.print(" //@$gatraits." + $gatraits.indexOf($gaindividual_traits.get(_j)));
    }
    out.print("\"");
    out.println(" />");
  }

    for (int _i = 0; _i < $gatraits.size(); _i++)
    { $GATrait $gatraitx_ = ($GATrait) $gatraits.get(_i);
       out.print("<$gatraits xsi:type=\"My:$GATrait\"");
    out.print(" item=\"" + $gatraitx_.getitem() + "\" ");
    out.print(" value=\"" + $gatraitx_.getvalue() + "\" ");
    out.println(" />");
  }

    for (int _i = 0; _i < $geneticalgorithms.size(); _i++)
    { $GeneticAlgorithm $geneticalgorithmx_ = ($GeneticAlgorithm) $geneticalgorithms.get(_i);
       out.print("<$geneticalgorithms xsi:type=\"My:$GeneticAlgorithm\"");
    out.print(" maxfitness=\"" + $geneticalgorithmx_.getmaxfitness() + "\" ");
    out.print(" population = \"");
    List $geneticalgorithm_population = $geneticalgorithmx_.getpopulation();
    for (int _j = 0; _j < $geneticalgorithm_population.size(); _j++)
    { out.print(" //@$gaindividuals." + $gaindividuals.indexOf($geneticalgorithm_population.get(_j)));
    }
    out.print("\"");
    out.println(" />");
  }

    for (int _i = 0; _i < $sequencess.size(); _i++)
    { $Sequences $sequencesx_ = ($Sequences) $sequencess.get(_i);
       out.print("<$sequencess xsi:type=\"My:$Sequences\"");
    out.println(" />");
  }

    for (int _i = 0; _i < $matrixs.size(); _i++)
    { $Matrix $matrixx_ = ($Matrix) $matrixs.get(_i);
       out.print("<$matrixs xsi:type=\"My:$Matrix\"");
    out.println(" />");
  }

    for (int _i = 0; _i < initialisensxs.size(); _i++)
    { Initialisensx initialisensxx_ = (Initialisensx) initialisensxs.get(_i);
       out.print("<initialisensxs xsi:type=\"My:Initialisensx\"");
    out.println(" />");
  }

    for (int _i = 0; _i < $simplexpoints.size(); _i++)
    { $SimplexPoint $simplexpointx_ = ($SimplexPoint) $simplexpoints.get(_i);
       out.print("<$simplexpoints xsi:type=\"My:$SimplexPoint\"");
    out.print(" fval=\"" + $simplexpointx_.getfval() + "\" ");
    out.println(" />");
  }

    for (int _i = 0; _i < $nsxfunctions.size(); _i++)
    { $NSXFunction $nsxfunctionx_ = ($NSXFunction) $nsxfunctions.get(_i);
       out.print("<$nsxfunctions xsi:type=\"My:$NSXFunction\"");
    out.println(" />");
  }

    for (int _i = 0; _i < $simplexs.size(); _i++)
    { $Simplex $simplexx_ = ($Simplex) $simplexs.get(_i);
       out.print("<$simplexs xsi:type=\"My:$Simplex\"");
    out.print(" dim=\"" + $simplexx_.getdim() + "\" ");
    out.print(" points = \"");
    List $simplex_points = $simplexx_.getpoints();
    for (int _j = 0; _j < $simplex_points.size(); _j++)
    { out.print(" //@$simplexpoints." + $simplexpoints.indexOf($simplex_points.get(_j)));
    }
    out.print("\"");
    if ($simplexx_.getf() instanceof $NSXFunction)
    {   out.print(" f=\"");
    out.print("//@$nsxfunctions." + $nsxfunctions.indexOf((($Simplex) $simplexs.get(_i)).getf()));
    out.print("\""); }
    out.print(" mean=\"");
    out.print("//@$simplexpoints." + $simplexpoints.indexOf((($Simplex) $simplexs.get(_i)).getmean()));
    out.print("\"");
    out.print(" reflection=\"");
    out.print("//@$simplexpoints." + $simplexpoints.indexOf((($Simplex) $simplexs.get(_i)).getreflection()));
    out.print("\"");
    out.println(" />");
  }

    for (int _i = 0; _i < pointss.size(); _i++)
    { Points pointsx_ = (Points) pointss.get(_i);
       out.print("<pointss xsi:type=\"My:Points\"");
    out.print(" X=\"" + pointsx_.getX() + "\" ");
    out.print(" Y=\"" + pointsx_.getY() + "\" ");
    out.println(" />");
  }

    for (int _i = 0; _i < resulttables.size(); _i++)
    { ResultTable resulttablex_ = (ResultTable) resulttables.get(_i);
       out.print("<resulttables xsi:type=\"My:ResultTable\"");
    out.print(" Diff=\"" + resulttablex_.getDiff() + "\" ");
    out.println(" />");
  }

    for (int _i = 0; _i < sheets.size(); _i++)
    { Sheet sheetx_ = (Sheet) sheets.get(_i);
       out.print("<sheets xsi:type=\"My:Sheet\"");
    out.println(" />");
  }

    out.println("</My:model>");
    out.close(); 
  }


  public void saveCSVModel()
  { try {
      File _nelsonseigal = new File("NelsonSeigal.csv");
      PrintWriter _out_nelsonseigal = new PrintWriter(new BufferedWriter(new FileWriter(_nelsonseigal)));
      for (int __i = 0; __i < nelsonseigals.size(); __i++)
      { NelsonSeigal nelsonseigalx = (NelsonSeigal) nelsonseigals.get(__i);
        nelsonseigalx.writeCSV(_out_nelsonseigal);
      }
      _out_nelsonseigal.close();
      File _initialisensx = new File("Initialisensx.csv");
      PrintWriter _out_initialisensx = new PrintWriter(new BufferedWriter(new FileWriter(_initialisensx)));
      for (int __i = 0; __i < initialisensxs.size(); __i++)
      { Initialisensx initialisensxx = (Initialisensx) initialisensxs.get(__i);
        initialisensxx.writeCSV(_out_initialisensx);
      }
      _out_initialisensx.close();
      File _points = new File("Points.csv");
      PrintWriter _out_points = new PrintWriter(new BufferedWriter(new FileWriter(_points)));
      for (int __i = 0; __i < pointss.size(); __i++)
      { Points pointsx = (Points) pointss.get(__i);
        pointsx.writeCSV(_out_points);
      }
      _out_points.close();
      File _resulttable = new File("ResultTable.csv");
      PrintWriter _out_resulttable = new PrintWriter(new BufferedWriter(new FileWriter(_resulttable)));
      for (int __i = 0; __i < resulttables.size(); __i++)
      { ResultTable resulttablex = (ResultTable) resulttables.get(__i);
        resulttablex.writeCSV(_out_resulttable);
      }
      _out_resulttable.close();
      File _sheet = new File("Sheet.csv");
      PrintWriter _out_sheet = new PrintWriter(new BufferedWriter(new FileWriter(_sheet)));
      for (int __i = 0; __i < sheets.size(); __i++)
      { Sheet sheetx = (Sheet) sheets.get(__i);
        sheetx.writeCSV(_out_sheet);
      }
      _out_sheet.close();
    }
    catch(Exception __e) { }
  }



  public void addExcelLib(ExcelLib oo) { excellibs.add(oo); }

  public void addApplication(Application oo) { applications.add(oo); addExcelLib(oo); }

  public void add$Bond($Bond oo) { $bonds.add(oo); }

  public void add$BondGroup($BondGroup oo) { $bondgroups.add(oo); }

  public void add$CashFlow($CashFlow oo) { $cashflows.add(oo); }

  public void addNelsonSeigal(NelsonSeigal oo) { nelsonseigals.add(oo); }

  public void add$GAIndividual($GAIndividual oo) { $gaindividuals.add(oo); }

  public void add$GATrait($GATrait oo) { $gatraits.add(oo); }

  public void add$GeneticAlgorithm($GeneticAlgorithm oo) { $geneticalgorithms.add(oo); }

  public void add$Sequences($Sequences oo) { $sequencess.add(oo); }

  public void add$Matrix($Matrix oo) { $matrixs.add(oo); }

  public void addInitialisensx(Initialisensx oo) { initialisensxs.add(oo); }

  public void add$SimplexPoint($SimplexPoint oo) { $simplexpoints.add(oo); }

  public void add$NFunction($NFunction oo) { $nfunctions.add(oo); }

  public void add$NSXFunction($NSXFunction oo) { $nsxfunctions.add(oo); add$NFunction(oo); }

  public void add$Simplex($Simplex oo) { $simplexs.add(oo); }

  public void addPoints(Points oo) { pointss.add(oo); addExcelLib(oo); }

  public void addResultTable(ResultTable oo) { resulttables.add(oo); addExcelLib(oo); }

  public void addSheet(Sheet oo) { sheets.add(oo); }



  public Application createApplication()
  { Application applicationx = new Application();
    addApplication(applicationx);
    return applicationx;
  }

  public $Bond create$Bond()
  { $Bond $bondx = new $Bond();
    add$Bond($bondx);
    return $bondx;
  }

  public $BondGroup create$BondGroup()
  { $BondGroup $bondgroupx = new $BondGroup();
    add$BondGroup($bondgroupx);
    return $bondgroupx;
  }

  public $CashFlow create$CashFlow()
  { $CashFlow $cashflowx = new $CashFlow();
    add$CashFlow($cashflowx);
    return $cashflowx;
  }

  public NelsonSeigal createNelsonSeigal()
  { NelsonSeigal nelsonseigalx = new NelsonSeigal();
    addNelsonSeigal(nelsonseigalx);
    return nelsonseigalx;
  }

  public $GAIndividual create$GAIndividual()
  { $GAIndividual $gaindividualx = new $GAIndividual();
    add$GAIndividual($gaindividualx);
    return $gaindividualx;
  }

  public $GATrait create$GATrait()
  { $GATrait $gatraitx = new $GATrait();
    add$GATrait($gatraitx);
    return $gatraitx;
  }

  public $GeneticAlgorithm create$GeneticAlgorithm()
  { $GeneticAlgorithm $geneticalgorithmx = new $GeneticAlgorithm();
    add$GeneticAlgorithm($geneticalgorithmx);
    return $geneticalgorithmx;
  }

  public $Sequences create$Sequences()
  { $Sequences $sequencesx = new $Sequences();
    add$Sequences($sequencesx);
    return $sequencesx;
  }

  public $Matrix create$Matrix()
  { $Matrix $matrixx = new $Matrix();
    add$Matrix($matrixx);
    return $matrixx;
  }

  public Initialisensx createInitialisensx()
  { Initialisensx initialisensxx = new Initialisensx();
    addInitialisensx(initialisensxx);
    return initialisensxx;
  }

  public $SimplexPoint create$SimplexPoint()
  { $SimplexPoint $simplexpointx = new $SimplexPoint();
    add$SimplexPoint($simplexpointx);
    return $simplexpointx;
  }

  public $NSXFunction create$NSXFunction()
  { $NSXFunction $nsxfunctionx = new $NSXFunction();
    add$NSXFunction($nsxfunctionx);
    return $nsxfunctionx;
  }

  public $Simplex create$Simplex()
  { $Simplex $simplexx = new $Simplex();
    add$Simplex($simplexx);
    return $simplexx;
  }

  public Points createPoints()
  { Points pointsx = new Points();
    addPoints(pointsx);
    return pointsx;
  }

  public ResultTable createResultTable()
  { ResultTable resulttablex = new ResultTable();
    addResultTable(resulttablex);
    return resulttablex;
  }

  public Sheet createSheet()
  { Sheet sheetx = new Sheet();
    addSheet(sheetx);
    return sheetx;
  }


public void setprice($Bond $bondx, double price_x) 
  { $bondx.setprice(price_x);
    }


public void setcoupon($Bond $bondx, double coupon_x) 
  { $bondx.setcoupon(coupon_x);
    }


public void setfrequency($Bond $bondx, int frequency_x) 
  { $bondx.setfrequency(frequency_x);
    }


public void setperiod($Bond $bondx, double period_x) 
  { $bondx.setperiod(period_x);
    }


public void setmaturity($Bond $bondx, double maturity_x) 
  { $bondx.setmaturity(maturity_x);
    }


public void setyield($Bond $bondx, double yield_x) 
  { $bondx.setyield(yield_x);
    }


public void setduration($Bond $bondx, double duration_x) 
  { $bondx.setduration(duration_x);
    }


public void setweight($Bond $bondx, double weight_x) 
  { $bondx.setweight(weight_x);
    }


public void setredemption($Bond $bondx, double redemption_x) 
  { $bondx.setredemption(redemption_x);
    }


  public void setflows($Bond $bondx, List flowsxx) 
  {   List _oldflowsxx = $bondx.getflows();
  for (int _i = 0; _i < flowsxx.size(); _i++)
  { $CashFlow _xx = ($CashFlow) flowsxx.get(_i);
    if (_oldflowsxx.contains(_xx)) { }
    else { $Bond.removeAllflows($bonds, _xx); }
  }
    $bondx.setflows(flowsxx);
      }


  public void setflows($Bond $bondx, int _ind, $CashFlow $cashflowx) 
  { $bondx.setflows(_ind,$cashflowx); }
  
  public void addflows($Bond $bondx, $CashFlow flowsxx) 
  {   $Bond.removeAllflows($bonds,flowsxx);
    $bondx.addflows(flowsxx);
   }


  public void removeflows($Bond $bondx, $CashFlow flowsxx) 
  { $bondx.removeflows(flowsxx);
    }


 public void unionflows($Bond $bondx, List flowsx)
  { for (int _i = 0; _i < flowsx.size(); _i++)
    { $CashFlow $cashflowxflows = ($CashFlow) flowsx.get(_i);
      addflows($bondx, $cashflowxflows);
     } } 


 public void subtractflows($Bond $bondx, List flowsx)
  { for (int _i = 0; _i < flowsx.size(); _i++)
    { $CashFlow $cashflowxflows = ($CashFlow) flowsx.get(_i);
      removeflows($bondx, $cashflowxflows);
     } } 


public void setinverseDsum($BondGroup $bondgroupx, double inverseDsum_x) 
  { $bondgroupx.setinverseDsum(inverseDsum_x);
    }


  public void setbonds($BondGroup $bondgroupx, List bondsxx) 
  {   List _oldbondsxx = $bondgroupx.getbonds();
  for (int _i = 0; _i < bondsxx.size(); _i++)
  { $Bond _xx = ($Bond) bondsxx.get(_i);
    if (_oldbondsxx.contains(_xx)) { }
    else { $BondGroup.removeAllbonds($bondgroups, _xx); }
  }
    $bondgroupx.setbonds(bondsxx);
      }


  public void addbonds($BondGroup $bondgroupx, $Bond bondsxx) 
  { if ($bondgroupx.getbonds().contains(bondsxx)) { return; }
    $BondGroup.removeAllbonds($bondgroups,bondsxx);
    $bondgroupx.addbonds(bondsxx);
   }


  public void removebonds($BondGroup $bondgroupx, $Bond bondsxx) 
  { $bondgroupx.removebonds(bondsxx);
    }


 public void unionbonds($BondGroup $bondgroupx, List bondsx)
  { for (int _i = 0; _i < bondsx.size(); _i++)
    { $Bond $bondxbonds = ($Bond) bondsx.get(_i);
      addbonds($bondgroupx, $bondxbonds);
     } } 


 public void subtractbonds($BondGroup $bondgroupx, List bondsx)
  { for (int _i = 0; _i < bondsx.size(); _i++)
    { $Bond $bondxbonds = ($Bond) bondsx.get(_i);
      removebonds($bondgroupx, $bondxbonds);
     } } 


public void setamount($CashFlow $cashflowx, double amount_x) 
  { $cashflowx.setamount(amount_x);
    }


public void settimePoint($CashFlow $cashflowx, double timePoint_x) 
  { $cashflowx.settimePoint(timePoint_x);
    }


public void setrate($CashFlow $cashflowx, double rate_x) 
  { $cashflowx.setrate(rate_x);
    }


public void setdiscount($CashFlow $cashflowx, double discount_x) 
  { $cashflowx.setdiscount(discount_x);
    }


public void setbeta1(NelsonSeigal nelsonseigalx, double beta1_x) 
  { nelsonseigalx.setbeta1(beta1_x);
    }


public void setbeta2(NelsonSeigal nelsonseigalx, double beta2_x) 
  { nelsonseigalx.setbeta2(beta2_x);
    }


public void setbeta3(NelsonSeigal nelsonseigalx, double beta3_x) 
  { nelsonseigalx.setbeta3(beta3_x);
    }


public void setlambda1(NelsonSeigal nelsonseigalx, double lambda1_x) 
  { nelsonseigalx.setlambda1(lambda1_x);
    }


public void setlambda2(NelsonSeigal nelsonseigalx, double lambda2_x) 
  { nelsonseigalx.setlambda2(lambda2_x);
    }


public void setfitnessval($GAIndividual $gaindividualx, double fitnessval_x) 
  { $gaindividualx.setfitnessval(fitnessval_x);
    }


  public void settraits($GAIndividual $gaindividualx, List traitsxx) 
  {     $gaindividualx.settraits(traitsxx);
      }


  public void settraits($GAIndividual $gaindividualx, int _ind, $GATrait $gatraitx) 
  { $gaindividualx.settraits(_ind,$gatraitx); }
  
  public void addtraits($GAIndividual $gaindividualx, $GATrait traitsxx) 
  {     $gaindividualx.addtraits(traitsxx);
   }


  public void removetraits($GAIndividual $gaindividualx, $GATrait traitsxx) 
  { $gaindividualx.removetraits(traitsxx);
    }


 public void uniontraits($GAIndividual $gaindividualx, List traitsx)
  { for (int _i = 0; _i < traitsx.size(); _i++)
    { $GATrait $gatraitxtraits = ($GATrait) traitsx.get(_i);
      addtraits($gaindividualx, $gatraitxtraits);
     } } 


 public void subtracttraits($GAIndividual $gaindividualx, List traitsx)
  { for (int _i = 0; _i < traitsx.size(); _i++)
    { $GATrait $gatraitxtraits = ($GATrait) traitsx.get(_i);
      removetraits($gaindividualx, $gatraitxtraits);
     } } 


public void setitem($GATrait $gatraitx, String item_x) 
  { $gatraitx.setitem(item_x);
    }


public void setvalue($GATrait $gatraitx, double value_x) 
  { $gatraitx.setvalue(value_x);
    }


public void setmaxfitness(double maxfitness_x) 
  { $GeneticAlgorithm.setmaxfitness(maxfitness_x);
  for (int i = 0; i < $geneticalgorithms.size(); i++)
  { $GeneticAlgorithm $geneticalgorithmx = ($GeneticAlgorithm) $geneticalgorithms.get(i);
    setmaxfitness($geneticalgorithmx,maxfitness_x); } }

  public void setmaxfitness($GeneticAlgorithm $geneticalgorithmx, double maxfitness_x) 
  { $geneticalgorithmx.localSetmaxfitness(maxfitness_x);
    }


  public void setpopulation($GeneticAlgorithm $geneticalgorithmx, List populationxx) 
  {   List _oldpopulationxx = $geneticalgorithmx.getpopulation();
  for (int _i = 0; _i < populationxx.size(); _i++)
  { $GAIndividual _xx = ($GAIndividual) populationxx.get(_i);
    if (_oldpopulationxx.contains(_xx)) { }
    else { $GeneticAlgorithm.removeAllpopulation($geneticalgorithms, _xx); }
  }
    $geneticalgorithmx.setpopulation(populationxx);
      }


  public void addpopulation($GeneticAlgorithm $geneticalgorithmx, $GAIndividual populationxx) 
  { if ($geneticalgorithmx.getpopulation().contains(populationxx)) { return; }
    $GeneticAlgorithm.removeAllpopulation($geneticalgorithms,populationxx);
    $geneticalgorithmx.addpopulation(populationxx);
   }


  public void removepopulation($GeneticAlgorithm $geneticalgorithmx, $GAIndividual populationxx) 
  { $geneticalgorithmx.removepopulation(populationxx);
    }


 public void unionpopulation($GeneticAlgorithm $geneticalgorithmx, List populationx)
  { for (int _i = 0; _i < populationx.size(); _i++)
    { $GAIndividual $gaindividualxpopulation = ($GAIndividual) populationx.get(_i);
      addpopulation($geneticalgorithmx, $gaindividualxpopulation);
     } } 


 public void subtractpopulation($GeneticAlgorithm $geneticalgorithmx, List populationx)
  { for (int _i = 0; _i < populationx.size(); _i++)
    { $GAIndividual $gaindividualxpopulation = ($GAIndividual) populationx.get(_i);
      removepopulation($geneticalgorithmx, $gaindividualxpopulation);
     } } 


public void setcoords($SimplexPoint $simplexpointx, List coords_x) 
  { $simplexpointx.setcoords(coords_x);
    }


  public void addcoords($SimplexPoint $simplexpointx, double coords_x)
  { $simplexpointx.addcoords(coords_x); }


  public void removecoords($SimplexPoint $simplexpointx, double coords_x)
  { $simplexpointx.removecoords(coords_x); }


public void setfval($SimplexPoint $simplexpointx, double fval_x) 
  { $simplexpointx.setfval(fval_x);
    }


public void setdim($Simplex $simplexx, int dim_x) 
  { $simplexx.setdim(dim_x);
    }


  public void setpoints($Simplex $simplexx, List pointsxx) 
  {   List _oldpointsxx = $simplexx.getpoints();
  for (int _i = 0; _i < pointsxx.size(); _i++)
  { $SimplexPoint _xx = ($SimplexPoint) pointsxx.get(_i);
    if (_oldpointsxx.contains(_xx)) { }
    else { $Simplex.removeAllpoints($simplexs, _xx); }
  }
    $simplexx.setpoints(pointsxx);
      }


  public void setpoints($Simplex $simplexx, int _ind, $SimplexPoint $simplexpointx) 
  { $simplexx.setpoints(_ind,$simplexpointx); }
  
  public void addpoints($Simplex $simplexx, $SimplexPoint pointsxx) 
  {   $Simplex.removeAllpoints($simplexs,pointsxx);
    $simplexx.addpoints(pointsxx);
   }


  public void removepoints($Simplex $simplexx, $SimplexPoint pointsxx) 
  { $simplexx.removepoints(pointsxx);
    }


 public void unionpoints($Simplex $simplexx, List pointsx)
  { for (int _i = 0; _i < pointsx.size(); _i++)
    { $SimplexPoint $simplexpointxpoints = ($SimplexPoint) pointsx.get(_i);
      addpoints($simplexx, $simplexpointxpoints);
     } } 


 public void subtractpoints($Simplex $simplexx, List pointsx)
  { for (int _i = 0; _i < pointsx.size(); _i++)
    { $SimplexPoint $simplexpointxpoints = ($SimplexPoint) pointsx.get(_i);
      removepoints($simplexx, $simplexpointxpoints);
     } } 


  public void setf($Simplex $simplexx, $NFunction fxx) 
  {   if ($simplexx.getf() == fxx) { return; }
    $simplexx.setf(fxx);
      }


  public void setmean($Simplex $simplexx, $SimplexPoint meanxx) 
  {   if ($simplexx.getmean() == meanxx) { return; }
    $simplexx.setmean(meanxx);
      }


  public void setreflection($Simplex $simplexx, $SimplexPoint reflectionxx) 
  {   if ($simplexx.getreflection() == reflectionxx) { return; }
    $simplexx.setreflection(reflectionxx);
      }


public void setX(Points pointsx, double X_x) 
  { pointsx.setX(X_x);
    }


public void setY(Points pointsx, double Y_x) 
  { pointsx.setY(Y_x);
    }


public void setDiff(ResultTable resulttablex, double Diff_x) 
  { resulttablex.setDiff(Diff_x);
    }



  public  List AllExcelLibSUM(List excellibxs,List s)
  { 
    List result = new Vector();
    for (int _i = 0; _i < excellibxs.size(); _i++)
    { ExcelLib excellibx = (ExcelLib) excellibxs.get(_i);
      result.add(new Double(excellibx.SUM(s)));
    }
    return result; 
  }

  public  List AllExcelLibPRODUCT(List excellibxs,List s)
  { 
    List result = new Vector();
    for (int _i = 0; _i < excellibxs.size(); _i++)
    { ExcelLib excellibx = (ExcelLib) excellibxs.get(_i);
      result.add(new Double(excellibx.PRODUCT(s)));
    }
    return result; 
  }

  public  List AllExcelLibSUMPRODUCT(List excellibxs,List s1,List s2)
  { 
    List result = new Vector();
    for (int _i = 0; _i < excellibxs.size(); _i++)
    { ExcelLib excellibx = (ExcelLib) excellibxs.get(_i);
      result.add(new Double(excellibx.SUMPRODUCT(s1, s2)));
    }
    return result; 
  }

  public double ESTIMATENSX(ExcelLib excellibx,List s1,List s2)
  { 
   double result = 0;
    //  if (!(s1.size() == s2.size())) { return result; } 
   result =   excellibx.ESTIMATENSX(s1, s2);
     return result;  }

  public  List AllExcelLibESTIMATENSX(List excellibxs,List s1,List s2)
  { 
    List result = new Vector();
    for (int i = 0; i < excellibxs.size(); i++)
    { ExcelLib excellibx = (ExcelLib) excellibxs.get(i);
      result.add(new Double(ESTIMATENSX(excellibx,s1, s2)));
    }
    return result; 
  }

  public  List AllExcelLibAVERAGE(List excellibxs,List s)
  { 
    List result = new Vector();
    for (int _i = 0; _i < excellibxs.size(); _i++)
    { ExcelLib excellibx = (ExcelLib) excellibxs.get(_i);
      result.add(new Double(excellibx.AVERAGE(s)));
    }
    return result; 
  }

  public  List AllExcelLibDATE(List excellibxs,int yr,int month,int day)
  { 
    List result = new Vector();
    for (int _i = 0; _i < excellibxs.size(); _i++)
    { ExcelLib excellibx = (ExcelLib) excellibxs.get(_i);
      result.add(new Integer(excellibx.DATE(yr, month, day)));
    }
    return result; 
  }

  public  List AllExcelLibDURATION(List excellibxs,int sett,int mat,double coupon,double yield,int freq)
  { 
    List result = new Vector();
    for (int _i = 0; _i < excellibxs.size(); _i++)
    { ExcelLib excellibx = (ExcelLib) excellibxs.get(_i);
      result.add(new Double(excellibx.DURATION(sett, mat, coupon, yield, freq)));
    }
    return result; 
  }

  public  List AllExcelLibDURATIONC(List excellibxs,int sett,int mat,double coupon,double yield,int freq)
  { 
    List result = new Vector();
    for (int _i = 0; _i < excellibxs.size(); _i++)
    { ExcelLib excellibx = (ExcelLib) excellibxs.get(_i);
      result.add(new Double(excellibx.DURATIONC(sett, mat, coupon, yield, freq)));
    }
    return result; 
  }

  public  List AllExcelLibRATE(List excellibxs,int npays,double payment,double pv)
  { 
    List result = new Vector();
    for (int _i = 0; _i < excellibxs.size(); _i++)
    { ExcelLib excellibx = (ExcelLib) excellibxs.get(_i);
      result.add(new Double(excellibx.RATE(npays, payment, pv)));
    }
    return result; 
  }

  public  List AllExcelLibRATE(List excellibxs,int npays,double payment,double pv,double fv)
  { 
    List result = new Vector();
    for (int _i = 0; _i < excellibxs.size(); _i++)
    { ExcelLib excellibx = (ExcelLib) excellibxs.get(_i);
      result.add(new Double(excellibx.RATE(npays, payment, pv, fv)));
    }
    return result; 
  }

  public  List AllExcelLibPRICE(List excellibxs,int sett,int mat,double crate,double yield,double redempt,int freq)
  { 
    List result = new Vector();
    for (int _i = 0; _i < excellibxs.size(); _i++)
    { ExcelLib excellibx = (ExcelLib) excellibxs.get(_i);
      result.add(new Double(excellibx.PRICE(sett, mat, crate, yield, redempt, freq)));
    }
    return result; 
  }

  public  List AllExcelLibMAX(List excellibxs,List s)
  { 
    List result = new Vector();
    for (int _i = 0; _i < excellibxs.size(); _i++)
    { ExcelLib excellibx = (ExcelLib) excellibxs.get(_i);
      result.add(new Double(excellibx.MAX(s)));
    }
    return result; 
  }

  public  List AllExcelLibMIN(List excellibxs,List s)
  { 
    List result = new Vector();
    for (int _i = 0; _i < excellibxs.size(); _i++)
    { ExcelLib excellibx = (ExcelLib) excellibxs.get(_i);
      result.add(new Double(excellibx.MIN(s)));
    }
    return result; 
  }

  public  List AllExcelLibSIN(List excellibxs,double x)
  { 
    List result = new Vector();
    for (int _i = 0; _i < excellibxs.size(); _i++)
    { ExcelLib excellibx = (ExcelLib) excellibxs.get(_i);
      result.add(new Double(excellibx.SIN(x)));
    }
    return result; 
  }

  public  List AllExcelLibCOS(List excellibxs,double x)
  { 
    List result = new Vector();
    for (int _i = 0; _i < excellibxs.size(); _i++)
    { ExcelLib excellibx = (ExcelLib) excellibxs.get(_i);
      result.add(new Double(excellibx.COS(x)));
    }
    return result; 
  }

  public  List AllExcelLibTAN(List excellibxs,double x)
  { 
    List result = new Vector();
    for (int _i = 0; _i < excellibxs.size(); _i++)
    { ExcelLib excellibx = (ExcelLib) excellibxs.get(_i);
      result.add(new Double(excellibx.TAN(x)));
    }
    return result; 
  }

  public  List AllExcelLibEXP(List excellibxs,double x)
  { 
    List result = new Vector();
    for (int _i = 0; _i < excellibxs.size(); _i++)
    { ExcelLib excellibx = (ExcelLib) excellibxs.get(_i);
      result.add(new Double(excellibx.EXP(x)));
    }
    return result; 
  }

  public  List AllExcelLibLOG(List excellibxs,double x)
  { 
    List result = new Vector();
    for (int _i = 0; _i < excellibxs.size(); _i++)
    { ExcelLib excellibx = (ExcelLib) excellibxs.get(_i);
      result.add(new Double(excellibx.LOG(x)));
    }
    return result; 
  }

  public  List AllExcelLibSQRT(List excellibxs,double x)
  { 
    List result = new Vector();
    for (int _i = 0; _i < excellibxs.size(); _i++)
    { ExcelLib excellibx = (ExcelLib) excellibxs.get(_i);
      result.add(new Double(excellibx.SQRT(x)));
    }
    return result; 
  }

  public  List AllExcelLibSUMSQDIFFS(List excellibxs,List s1,List s2)
  { 
    List result = new Vector();
    for (int _i = 0; _i < excellibxs.size(); _i++)
    { ExcelLib excellibx = (ExcelLib) excellibxs.get(_i);
      result.add(new Double(excellibx.SUMSQDIFFS(s1, s2)));
    }
    return result; 
  }

  public void sheet2(Application applicationx,double Diffx)
  {   applicationx.sheet2(Diffx);
   }

  public void sheet2outer(Application applicationx)
  {   applicationx.sheet2outer();
   }

  public void defineFlows0($Bond $bondx)
  {   $bondx.defineFlows0();
   }

  public  List All$BonddefineFlows0(List $bondxs)
  { 
    List result = new Vector();
    for (int i = 0; i < $bondxs.size(); i++)
    { $Bond $bondx = ($Bond) $bondxs.get(i);
      defineFlows0($bondx);
    }
    return result; 
  }

  public void defineFlows1($Bond $bondx)
  {   $bondx.defineFlows1();
   }

  public  List All$BonddefineFlows1(List $bondxs)
  { 
    List result = new Vector();
    for (int i = 0; i < $bondxs.size(); i++)
    { $Bond $bondx = ($Bond) $bondxs.get(i);
      defineFlows1($bondx);
    }
    return result; 
  }

  public void defineFlows2($Bond $bondx)
  {   $bondx.defineFlows2();
   }

  public  List All$BonddefineFlows2(List $bondxs)
  { 
    List result = new Vector();
    for (int i = 0; i < $bondxs.size(); i++)
    { $Bond $bondx = ($Bond) $bondxs.get(i);
      defineFlows2($bondx);
    }
    return result; 
  }

  public  List All$BondtotalValue(List $bondxs,double r)
  { 
    List result = new Vector();
    for (int _i = 0; _i < $bondxs.size(); _i++)
    { $Bond $bondx = ($Bond) $bondxs.get(_i);
      result.add(new Double($bondx.totalValue(r)));
    }
    return result; 
  }

  public  List All$BondpresentValue(List $bondxs,double r)
  { 
    List result = new Vector();
    for (int _i = 0; _i < $bondxs.size(); _i++)
    { $Bond $bondx = ($Bond) $bondxs.get(_i);
      result.add(new Double($bondx.presentValue(r)));
    }
    return result; 
  }

  public  List All$BondmacaulayDuration(List $bondxs)
  { 
    List result = new Vector();
    for (int _i = 0; _i < $bondxs.size(); _i++)
    { $Bond $bondx = ($Bond) $bondxs.get(_i);
      result.add(new Double($bondx.macaulayDuration()));
    }
    return result; 
  }

  public  List All$BondmacaulayDurationC(List $bondxs)
  { 
    List result = new Vector();
    for (int _i = 0; _i < $bondxs.size(); _i++)
    { $Bond $bondx = ($Bond) $bondxs.get(_i);
      result.add(new Double($bondx.macaulayDurationC()));
    }
    return result; 
  }

  public  List All$Bondsecant(List $bondxs,double rn,double rminus,double tvminus,double tol)
  { 
    List result = new Vector();
    for (int _i = 0; _i < $bondxs.size(); _i++)
    { $Bond $bondx = ($Bond) $bondxs.get(_i);
      result.add(new Double($bondx.secant(rn, rminus, tvminus, tol)));
    }
    return result; 
  }

  public  List All$Bonddosecant(List $bondxs,double tol)
  { 
    List result = new Vector();
    for (int _i = 0; _i < $bondxs.size(); _i++)
    { $Bond $bondx = ($Bond) $bondxs.get(_i);
      result.add(new Double($bondx.dosecant(tol)));
    }
    return result; 
  }

  public void initialisensx2($Bond $bondx)
  {   $bondx.initialisensx2();
   }

  public  List All$GAIndividualisValid(List $gaindividualxs)
  { 
    List result = new Vector();
    for (int _i = 0; _i < $gaindividualxs.size(); _i++)
    { $GAIndividual $gaindividualx = ($GAIndividual) $gaindividualxs.get(_i);
      result.add(new Boolean($gaindividualx.isValid()));
    }
    return result; 
  }

  public  List All$GAIndividualfitnessnsx(List $gaindividualxs)
  { 
    List result = new Vector();
    for (int _i = 0; _i < $gaindividualxs.size(); _i++)
    { $GAIndividual $gaindividualx = ($GAIndividual) $gaindividualxs.get(_i);
      result.add(new Double($gaindividualx.fitnessnsx()));
    }
    return result; 
  }

  public void initialisensx4($GeneticAlgorithm $geneticalgorithmx,double lambda1,double lambda2,$Bond r1,$Bond r2,$Bond r3,List m,double d)
  {   $geneticalgorithmx.initialisensx4(lambda1, lambda2, r1, r2, r3, m, d);
   }

  public void initialisensx4outer($GeneticAlgorithm $geneticalgorithmx)
  {   $geneticalgorithmx.initialisensx4outer();
   }

  public void initialisensx5($GeneticAlgorithm $geneticalgorithmx,$GAIndividual p)
  {   $geneticalgorithmx.initialisensx5(p);
   }

  public void initialisensx5outer($GeneticAlgorithm $geneticalgorithmx)
  {   $geneticalgorithmx.initialisensx5outer();
   }

  public void initialisensx6($GeneticAlgorithm $geneticalgorithmx)
  {   $geneticalgorithmx.initialisensx6();
   }

  public void initialisensx7($GeneticAlgorithm $geneticalgorithmx)
  {   $geneticalgorithmx.initialisensx7();
   }

  public void initialisensx8($GeneticAlgorithm $geneticalgorithmx,$GAIndividual maxresult)
  {   $geneticalgorithmx.initialisensx8(maxresult);
   }

  public void initialisensx8outer($GeneticAlgorithm $geneticalgorithmx)
  {   $geneticalgorithmx.initialisensx8outer();
   }

  public void initialisensx9($GeneticAlgorithm $geneticalgorithmx,$GAIndividual maxresult)
  {   $geneticalgorithmx.initialisensx9(maxresult);
   }

  public void initialisensx9outer($GeneticAlgorithm $geneticalgorithmx)
  {   $geneticalgorithmx.initialisensx9outer();
   }

  public  List All$NFunctionapply(List $nfunctionxs,$SimplexPoint p)
  { 
    List result = new Vector();
    for (int _i = 0; _i < $nfunctionxs.size(); _i++)
    { $NFunction $nfunctionx = ($NFunction) $nfunctionxs.get(_i);
      result.add(new Double($nfunctionx.apply(p)));
    }
    return result; 
  }

  public  List All$NSXFunctionapply(List $nsxfunctionxs,$SimplexPoint p)
  { 
    List result = new Vector();
    for (int _i = 0; _i < $nsxfunctionxs.size(); _i++)
    { $NSXFunction $nsxfunctionx = ($NSXFunction) $nsxfunctionxs.get(_i);
      result.add(new Double($nsxfunctionx.apply(p)));
    }
    return result; 
  }

  public boolean sortPoints($Simplex $simplexx)
  { 
   boolean result = false;
   result =   $simplexx.sortPoints();
     return result;  }

  public  List All$SimplexsortPoints(List $simplexxs)
  { 
    List result = new Vector();
    for (int i = 0; i < $simplexxs.size(); i++)
    { $Simplex $simplexx = ($Simplex) $simplexxs.get(i);
      result.add(new Boolean(sortPoints($simplexx)));
    }
    return result; 
  }

  public  List All$Simplexdiameter(List $simplexxs)
  { 
    List result = new Vector();
    for (int _i = 0; _i < $simplexxs.size(); _i++)
    { $Simplex $simplexx = ($Simplex) $simplexxs.get(_i);
      result.add(new Double($simplexx.diameter()));
    }
    return result; 
  }

  public void initialise($Simplex $simplexx,$SimplexPoint x)
  {   $simplexx.initialise(x);
   }

  public  List All$Simplexinitialise(List $simplexxs,$SimplexPoint x)
  { 
    List result = new Vector();
    for (int i = 0; i < $simplexxs.size(); i++)
    { $Simplex $simplexx = ($Simplex) $simplexxs.get(i);
      initialise($simplexx,x);
    }
    return result; 
  }

  public void computeMeanReflection($Simplex $simplexx)
  {   $simplexx.computeMeanReflection();
   }

  public  List All$SimplexcomputeMeanReflection(List $simplexxs)
  { 
    List result = new Vector();
    for (int i = 0; i < $simplexxs.size(); i++)
    { $Simplex $simplexx = ($Simplex) $simplexxs.get(i);
      computeMeanReflection($simplexx);
    }
    return result; 
  }

  public void expand($Simplex $simplexx)
  {   $simplexx.expand();
   }

  public  List All$Simplexexpand(List $simplexxs)
  { 
    List result = new Vector();
    for (int i = 0; i < $simplexxs.size(); i++)
    { $Simplex $simplexx = ($Simplex) $simplexxs.get(i);
      expand($simplexx);
    }
    return result; 
  }

  public void shrink($Simplex $simplexx,$SimplexPoint x1)
  {   $simplexx.shrink(x1);
   }

  public  List All$Simplexshrink(List $simplexxs,$SimplexPoint x1)
  { 
    List result = new Vector();
    for (int i = 0; i < $simplexxs.size(); i++)
    { $Simplex $simplexx = ($Simplex) $simplexxs.get(i);
      shrink($simplexx,x1);
    }
    return result; 
  }

  public void contractInside($Simplex $simplexx,$SimplexPoint c)
  {   $simplexx.contractInside(c);
   }

  public  List All$SimplexcontractInside(List $simplexxs,$SimplexPoint c)
  { 
    List result = new Vector();
    for (int i = 0; i < $simplexxs.size(); i++)
    { $Simplex $simplexx = ($Simplex) $simplexxs.get(i);
      contractInside($simplexx,c);
    }
    return result; 
  }

  public void contractOutside($Simplex $simplexx,$SimplexPoint cc)
  {   $simplexx.contractOutside(cc);
   }

  public  List All$SimplexcontractOutside(List $simplexxs,$SimplexPoint cc)
  { 
    List result = new Vector();
    for (int i = 0; i < $simplexxs.size(); i++)
    { $Simplex $simplexx = ($Simplex) $simplexxs.get(i);
      contractOutside($simplexx,cc);
    }
    return result; 
  }

  public void contract($Simplex $simplexx)
  {   $simplexx.contract();
   }

  public  List All$Simplexcontract(List $simplexxs)
  { 
    List result = new Vector();
    for (int i = 0; i < $simplexxs.size(); i++)
    { $Simplex $simplexx = ($Simplex) $simplexxs.get(i);
      contract($simplexx);
    }
    return result; 
  }

  public void reflectExpand($Simplex $simplexx)
  {   $simplexx.reflectExpand();
   }

  public  List All$SimplexreflectExpand(List $simplexxs)
  { 
    List result = new Vector();
    for (int i = 0; i < $simplexxs.size(); i++)
    { $Simplex $simplexx = ($Simplex) $simplexxs.get(i);
      reflectExpand($simplexx);
    }
    return result; 
  }

  public  List All$Simplexiterate(List $simplexxs,$SimplexPoint x,double tol)
  { 
    List result = new Vector();
    for (int _i = 0; _i < $simplexxs.size(); _i++)
    { $Simplex $simplexx = ($Simplex) $simplexxs.get(_i);
      result.add($simplexx.iterate(x, tol));
    }
    return result; 
  }



  public void killAllExcelLib(List excellibxx)
  { for (int _i = 0; _i < excellibxx.size(); _i++)
    { killExcelLib((ExcelLib) excellibxx.get(_i)); }
  }

  public void killExcelLib(ExcelLib excellibxx)
  { if (excellibxx == null) { return; }
   excellibs.remove(excellibxx);
  }

  public void killAbstractExcelLib(ExcelLib excellibxx)
  {
    if (excellibxx instanceof Application)
    { killApplication((Application) excellibxx); }
    if (excellibxx instanceof Points)
    { killPoints((Points) excellibxx); }
    if (excellibxx instanceof ResultTable)
    { killResultTable((ResultTable) excellibxx); }
  }

  public void killAbstractExcelLib(List _l)
  { for (int _i = 0; _i < _l.size(); _i++)
    { ExcelLib _e = (ExcelLib) _l.get(_i);
      killAbstractExcelLib(_e);
    }
  }



  public void killAllApplication(List applicationxx)
  { for (int _i = 0; _i < applicationxx.size(); _i++)
    { killApplication((Application) applicationxx.get(_i)); }
  }

  public void killApplication(Application applicationxx)
  { if (applicationxx == null) { return; }
   applications.remove(applicationxx);
  killExcelLib(applicationxx);
  }



  public void killAll$Bond(List $bondxx)
  { for (int _i = 0; _i < $bondxx.size(); _i++)
    { kill$Bond(($Bond) $bondxx.get(_i)); }
  }

  public void kill$Bond($Bond $bondxx)
  { if ($bondxx == null) { return; }
   $bonds.remove($bondxx);
    Vector _1qrangebonds$BondGroup = new Vector();
    _1qrangebonds$BondGroup.addAll($bondgroups);
    for (int _i = 0; _i < _1qrangebonds$BondGroup.size(); _i++)
    { $BondGroup $bondgroupx = ($BondGroup) _1qrangebonds$BondGroup.get(_i);
      if ($bondgroupx != null && $bondgroupx.getbonds().contains($bondxx))
      { removebonds($bondgroupx,$bondxx); }
    }
  }



  public void killAll$BondGroup(List $bondgroupxx)
  { for (int _i = 0; _i < $bondgroupxx.size(); _i++)
    { kill$BondGroup(($BondGroup) $bondgroupxx.get(_i)); }
  }

  public void kill$BondGroup($BondGroup $bondgroupxx)
  { if ($bondgroupxx == null) { return; }
   $bondgroups.remove($bondgroupxx);
  }



  public void killAll$CashFlow(List $cashflowxx)
  { for (int _i = 0; _i < $cashflowxx.size(); _i++)
    { kill$CashFlow(($CashFlow) $cashflowxx.get(_i)); }
  }

  public void kill$CashFlow($CashFlow $cashflowxx)
  { if ($cashflowxx == null) { return; }
   $cashflows.remove($cashflowxx);
    Vector _1qrangeflows$Bond = new Vector();
    _1qrangeflows$Bond.addAll($bonds);
    for (int _i = 0; _i < _1qrangeflows$Bond.size(); _i++)
    { $Bond $bondx = ($Bond) _1qrangeflows$Bond.get(_i);
      if ($bondx != null && $bondx.getflows().contains($cashflowxx))
      { removeflows($bondx,$cashflowxx); }
    }
  }



  public void killAllNelsonSeigal(List nelsonseigalxx)
  { for (int _i = 0; _i < nelsonseigalxx.size(); _i++)
    { killNelsonSeigal((NelsonSeigal) nelsonseigalxx.get(_i)); }
  }

  public void killNelsonSeigal(NelsonSeigal nelsonseigalxx)
  { if (nelsonseigalxx == null) { return; }
   nelsonseigals.remove(nelsonseigalxx);
  }



  public void killAll$GAIndividual(List $gaindividualxx)
  { for (int _i = 0; _i < $gaindividualxx.size(); _i++)
    { kill$GAIndividual(($GAIndividual) $gaindividualxx.get(_i)); }
  }

  public void kill$GAIndividual($GAIndividual $gaindividualxx)
  { if ($gaindividualxx == null) { return; }
   $gaindividuals.remove($gaindividualxx);
    Vector _1qrangepopulation$GeneticAlgorithm = new Vector();
    _1qrangepopulation$GeneticAlgorithm.addAll($geneticalgorithms);
    for (int _i = 0; _i < _1qrangepopulation$GeneticAlgorithm.size(); _i++)
    { $GeneticAlgorithm $geneticalgorithmx = ($GeneticAlgorithm) _1qrangepopulation$GeneticAlgorithm.get(_i);
      if ($geneticalgorithmx != null && $geneticalgorithmx.getpopulation().contains($gaindividualxx))
      { removepopulation($geneticalgorithmx,$gaindividualxx); }
    }
  }



  public void killAll$GATrait(List $gatraitxx)
  { for (int _i = 0; _i < $gatraitxx.size(); _i++)
    { kill$GATrait(($GATrait) $gatraitxx.get(_i)); }
  }

  public void kill$GATrait($GATrait $gatraitxx)
  { if ($gatraitxx == null) { return; }
   $gatraits.remove($gatraitxx);
    Vector _1qrangetraits$GAIndividual = new Vector();
    _1qrangetraits$GAIndividual.addAll($gaindividuals);
    for (int _i = 0; _i < _1qrangetraits$GAIndividual.size(); _i++)
    { $GAIndividual $gaindividualx = ($GAIndividual) _1qrangetraits$GAIndividual.get(_i);
      if ($gaindividualx != null && $gaindividualx.gettraits().contains($gatraitxx))
      { removetraits($gaindividualx,$gatraitxx); }
    }
  }



  public void killAll$GeneticAlgorithm(List $geneticalgorithmxx)
  { for (int _i = 0; _i < $geneticalgorithmxx.size(); _i++)
    { kill$GeneticAlgorithm(($GeneticAlgorithm) $geneticalgorithmxx.get(_i)); }
  }

  public void kill$GeneticAlgorithm($GeneticAlgorithm $geneticalgorithmxx)
  { if ($geneticalgorithmxx == null) { return; }
   $geneticalgorithms.remove($geneticalgorithmxx);
  }



  public void killAll$Sequences(List $sequencesxx)
  { for (int _i = 0; _i < $sequencesxx.size(); _i++)
    { kill$Sequences(($Sequences) $sequencesxx.get(_i)); }
  }

  public void kill$Sequences($Sequences $sequencesxx)
  { if ($sequencesxx == null) { return; }
   $sequencess.remove($sequencesxx);
  }



  public void killAll$Matrix(List $matrixxx)
  { for (int _i = 0; _i < $matrixxx.size(); _i++)
    { kill$Matrix(($Matrix) $matrixxx.get(_i)); }
  }

  public void kill$Matrix($Matrix $matrixxx)
  { if ($matrixxx == null) { return; }
   $matrixs.remove($matrixxx);
  }



  public void killAllInitialisensx(List initialisensxxx)
  { for (int _i = 0; _i < initialisensxxx.size(); _i++)
    { killInitialisensx((Initialisensx) initialisensxxx.get(_i)); }
  }

  public void killInitialisensx(Initialisensx initialisensxxx)
  { if (initialisensxxx == null) { return; }
   initialisensxs.remove(initialisensxxx);
  }



  public void killAll$SimplexPoint(List $simplexpointxx)
  { for (int _i = 0; _i < $simplexpointxx.size(); _i++)
    { kill$SimplexPoint(($SimplexPoint) $simplexpointxx.get(_i)); }
  }

  public void kill$SimplexPoint($SimplexPoint $simplexpointxx)
  { if ($simplexpointxx == null) { return; }
   $simplexpoints.remove($simplexpointxx);
    Vector _1removedmean$Simplex = new Vector();
    Vector _1removedreflection$Simplex = new Vector();
    Vector _1qrangepoints$Simplex = new Vector();
    _1qrangepoints$Simplex.addAll($simplexs);
    for (int _i = 0; _i < _1qrangepoints$Simplex.size(); _i++)
    { $Simplex $simplexx = ($Simplex) _1qrangepoints$Simplex.get(_i);
      if ($simplexx != null && $simplexx.getpoints().contains($simplexpointxx))
      { removepoints($simplexx,$simplexpointxx); }
    }
    Vector _1qrangemean$Simplex = new Vector();
    _1qrangemean$Simplex.addAll($simplexs);
    for (int _i = 0; _i < _1qrangemean$Simplex.size(); _i++)
    { $Simplex $simplexx = ($Simplex) _1qrangemean$Simplex.get(_i);
      if ($simplexx != null && $simplexpointxx.equals($simplexx.getmean()))
      { _1removedmean$Simplex.add($simplexx);
        $simplexx.setmean(null);
      }
    }
    Vector _1qrangereflection$Simplex = new Vector();
    _1qrangereflection$Simplex.addAll($simplexs);
    for (int _i = 0; _i < _1qrangereflection$Simplex.size(); _i++)
    { $Simplex $simplexx = ($Simplex) _1qrangereflection$Simplex.get(_i);
      if ($simplexx != null && $simplexpointxx.equals($simplexx.getreflection()))
      { _1removedreflection$Simplex.add($simplexx);
        $simplexx.setreflection(null);
      }
    }
    for (int _i = 0; _i < _1removedmean$Simplex.size(); _i++)
    { kill$Simplex(($Simplex) _1removedmean$Simplex.get(_i)); }
    for (int _i = 0; _i < _1removedreflection$Simplex.size(); _i++)
    { kill$Simplex(($Simplex) _1removedreflection$Simplex.get(_i)); }
  }



  public void killAll$NFunction(List $nfunctionxx)
  { for (int _i = 0; _i < $nfunctionxx.size(); _i++)
    { kill$NFunction(($NFunction) $nfunctionxx.get(_i)); }
  }

  public void kill$NFunction($NFunction $nfunctionxx)
  { if ($nfunctionxx == null) { return; }
   $nfunctions.remove($nfunctionxx);
    Vector _1removedf$Simplex = new Vector();
    Vector _1qrangef$Simplex = new Vector();
    _1qrangef$Simplex.addAll($simplexs);
    for (int _i = 0; _i < _1qrangef$Simplex.size(); _i++)
    { $Simplex $simplexx = ($Simplex) _1qrangef$Simplex.get(_i);
      if ($simplexx != null && $nfunctionxx.equals($simplexx.getf()))
      { _1removedf$Simplex.add($simplexx);
        $simplexx.setf(null);
      }
    }
    for (int _i = 0; _i < _1removedf$Simplex.size(); _i++)
    { kill$Simplex(($Simplex) _1removedf$Simplex.get(_i)); }
  }

  public void killAbstract$NFunction($NFunction $nfunctionxx)
  {
    if ($nfunctionxx instanceof $NSXFunction)
    { kill$NSXFunction(($NSXFunction) $nfunctionxx); }
  }

  public void killAbstract$NFunction(List _l)
  { for (int _i = 0; _i < _l.size(); _i++)
    { $NFunction _e = ($NFunction) _l.get(_i);
      killAbstract$NFunction(_e);
    }
  }



  public void killAll$NSXFunction(List $nsxfunctionxx)
  { for (int _i = 0; _i < $nsxfunctionxx.size(); _i++)
    { kill$NSXFunction(($NSXFunction) $nsxfunctionxx.get(_i)); }
  }

  public void kill$NSXFunction($NSXFunction $nsxfunctionxx)
  { if ($nsxfunctionxx == null) { return; }
   $nsxfunctions.remove($nsxfunctionxx);
  kill$NFunction($nsxfunctionxx);
  }



  public void killAll$Simplex(List $simplexxx)
  { for (int _i = 0; _i < $simplexxx.size(); _i++)
    { kill$Simplex(($Simplex) $simplexxx.get(_i)); }
  }

  public void kill$Simplex($Simplex $simplexxx)
  { if ($simplexxx == null) { return; }
   $simplexs.remove($simplexxx);
  }



  public void killAllPoints(List pointsxx)
  { for (int _i = 0; _i < pointsxx.size(); _i++)
    { killPoints((Points) pointsxx.get(_i)); }
  }

  public void killPoints(Points pointsxx)
  { if (pointsxx == null) { return; }
   pointss.remove(pointsxx);
  killExcelLib(pointsxx);
  }



  public void killAllResultTable(List resulttablexx)
  { for (int _i = 0; _i < resulttablexx.size(); _i++)
    { killResultTable((ResultTable) resulttablexx.get(_i)); }
  }

  public void killResultTable(ResultTable resulttablexx)
  { if (resulttablexx == null) { return; }
   resulttables.remove(resulttablexx);
  killExcelLib(resulttablexx);
  }



  public void killAllSheet(List sheetxx)
  { for (int _i = 0; _i < sheetxx.size(); _i++)
    { killSheet((Sheet) sheetxx.get(_i)); }
  }

  public void killSheet(Sheet sheetxx)
  { if (sheetxx == null) { return; }
   sheets.remove(sheetxx);
  }




  
  
  public void initialisensx(List s1,List s2) 
  { 

     $GeneticAlgorithm g = new $GeneticAlgorithm();
    Controller.inst().add$GeneticAlgorithm(g);
    {} /* No update form for: true */
    List _range30 = new Vector();
  _range30.addAll(Controller.inst().$bonds);
  for (int _i29 = 0; _i29 < _range30.size(); _i29++)
  { $Bond loopvar_0 = ($Bond) _range30.get(_i29);
       Controller.inst().initialisensx2(loopvar_0);
  }
    List _range32 = new Vector();
  _range32.addAll(Set.integerSubrange(1,s1.size()));
  for (int _i31 = 0; _i31 < _range32.size(); _i31++)
  { int i = ((Integer) _range32.get(_i31)).intValue();
       $Bond b = new $Bond();
    Controller.inst().add$Bond(b);
    Controller.inst().setduration(b,((Double) s1.get(i - 1)).doubleValue());
    Controller.inst().setyield(b,((Double) s2.get(i - 1)).doubleValue());
  }
    List _range34 = new Vector();
  _range34.addAll(Controller.inst().$geneticalgorithms);
  for (int _i33 = 0; _i33 < _range34.size(); _i33++)
  { $GeneticAlgorithm loopvar_1 = ($GeneticAlgorithm) _range34.get(_i33);
       Controller.inst().initialisensx4outer(loopvar_1);
  }
    List _range36 = new Vector();
  _range36.addAll(Controller.inst().$geneticalgorithms);
  for (int _i35 = 0; _i35 < _range36.size(); _i35++)
  { $GeneticAlgorithm loopvar_2 = ($GeneticAlgorithm) _range36.get(_i35);
       Controller.inst().initialisensx5outer(loopvar_2);
  }
    List _range38 = new Vector();
  _range38.addAll(Controller.inst().$geneticalgorithms);
  for (int _i37 = 0; _i37 < _range38.size(); _i37++)
  { $GeneticAlgorithm loopvar_3 = ($GeneticAlgorithm) _range38.get(_i37);
       Controller.inst().initialisensx6(loopvar_3);
  }
    List _range40 = new Vector();
  _range40.addAll(Controller.inst().$geneticalgorithms);
  for (int _i39 = 0; _i39 < _range40.size(); _i39++)
  { $GeneticAlgorithm loopvar_4 = ($GeneticAlgorithm) _range40.get(_i39);
       Controller.inst().initialisensx7(loopvar_4);
  }
    List _range42 = new Vector();
  _range42.addAll(Controller.inst().$geneticalgorithms);
  for (int _i41 = 0; _i41 < _range42.size(); _i41++)
  { $GeneticAlgorithm loopvar_5 = ($GeneticAlgorithm) _range42.get(_i41);
       Controller.inst().initialisensx8outer(loopvar_5);
  }
    List _range44 = new Vector();
  _range44.addAll(Controller.inst().$geneticalgorithms);
  for (int _i43 = 0; _i43 < _range44.size(); _i43++)
  { $GeneticAlgorithm loopvar_6 = ($GeneticAlgorithm) _range44.get(_i43);
       Controller.inst().initialisensx9outer(loopvar_6);
  }

  }



  
  public void sheet() 
  { 

     Application applicationx = new Application();
    Controller.inst().addApplication(applicationx);
    {} /* No update form for: true */
    List _range46 = new Vector();
  _range46.addAll(Controller.inst().applications);
  for (int _i45 = 0; _i45 < _range46.size(); _i45++)
  { Application loopvar_7 = (Application) _range46.get(_i45);
       Controller.inst().sheet2outer(loopvar_7);
  }

  }


 
}



