#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#define ALLOCATIONSIZE 10

#define TRUE 1
#define FALSE 0

#include "ocl.h"

#include "app.h"

struct AA** aa_instances = NULL;
int aa_size = 0;

struct AA** newAAList(void)
{ return (struct AA**) calloc(ALLOCATIONSIZE, sizeof(struct AA*)); }

int getAA_x(struct AA* self) { return self->x; }

void setAA_x(struct AA* self, int _value) { self->x = _value; }

int* getAllAA_x(struct AA* _col[])
{ int n = length((void**) _col);
  int* result = (int*) calloc(n, sizeof(int));
  int i = 0;
  for ( ; i < n; i++)
  { result[i] = getAA_x(_col[i]); }
  return result;
}

struct AA** appendAA(struct AA* col[], struct AA* ex)
   { struct AA** result;
     int len = length((void**) col);
     if (len % ALLOCATIONSIZE == 0)
     { result = (struct AA**) calloc(len + ALLOCATIONSIZE + 1, sizeof(struct AA*));
       int i = 0;
       for ( ; i < len; i++) { result[i] = col[i]; }
     }
     else { result = col; }
     result[len] = ex;
     result[len+1] = NULL;
     return result;
   }

struct AA* createAA(void)
{ struct AA* result = (struct AA*) malloc(sizeof(struct AA));
  result->x = 0;
  aa_instances = appendAA(aa_instances, result);
  aa_size++;
  return result;
}

struct AA** insertAA(struct AA* col[], struct AA* self)
  { if (isIn((void*) self, (void**) col))
    { return col; }
    return appendAA(col,self);
  }

  struct AA** subrangeAA(struct AA** col, int i, int j)
  { int len = length((void**) col);
    if (i < 1) { i = 1; }
    if (j > len) { j = len; }
    if (i > j) { return NULL; }
    struct AA** result = (struct AA**) calloc(j - i + 2, sizeof(struct AA*));
    int k = i-1;
    int l = 0;
    for ( ; k < j; k++, l++)
    { result[l] = col[k]; }
    result[l] = NULL;
    return result;
  }

  struct AA** reverseAA(struct AA** col)
  { int n = length((void**) col);
    struct AA** result = (struct AA**) calloc(n+1, sizeof(struct AA*));
    int i = 0;
    int x = n-1;
    for ( ; i < n; i++, x--)
    { result[i] = col[x]; }
    result[n] = NULL;
    return result;
  }

struct AA** removeAA(struct AA* col[], struct AA* ex)
{ int len = length((void**) col);
  struct AA** result = (struct AA**) calloc(len+1, sizeof(struct AA*));
  int j = 0;
  int i = 0;
  for ( ; i < len; i++)
  { struct AA* _e = col[i];
    if (_e == NULL)
    { result[j] = NULL;
      return result; 
    }
    if (_e == ex) { }
    else
    { result[j] = _e; j++; }
  }
  result[j] = NULL;
  return result;
}

struct AA** removeAllAA(struct AA* _col1[], struct AA* _col2[])
{ int n = length((void**) _col1);
  struct AA** result = (struct AA**) calloc(n+1, sizeof(struct AA*));
  int i = 0; int j = 0;
  for ( ; i < n; i++)
  { struct AA* ex = _col1[i];
    if (isIn((void*) ex, (void**) _col2)) {}
    else 
    { result[j] = ex; j++; }
  }
  result[j] = NULL;
  return result;
}

struct AA** frontAA(struct AA* _col[])
{ int n = length((void**) _col);
  return subrangeAA(_col, 1, n-1); }

struct AA** tailAA(struct AA* _col[])
{ int n = length((void**) _col);
  return subrangeAA(_col, 2, n); }

int op_1(int i)
{   return (i * i);
 }

void sumsq(struct AA* self)
{   setAA_x(self, intSum(2, 200, op_1));

   }

int main(int _argc, char* _argv[]) { return 0; }
